{
    "$graph": [
        {
            "class": "Workflow",
            "label": "wgs alignment with qc",
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "type": "record",
                            "name": "#labelled_file.yml/labelled_file",
                            "label": "a file with a label",
                            "fields": [
                                {
                                    "type": "File",
                                    "name": "#labelled_file.yml/labelled_file/file"
                                },
                                {
                                    "type": "string",
                                    "name": "#labelled_file.yml/labelled_file/label"
                                }
                            ]
                        },
                        {
                            "type": "record",
                            "name": "#sequence_data.yml/sequence_data",
                            "label": "sequence data with readgroup information",
                            "fields": [
                                {
                                    "type": "string",
                                    "name": "#sequence_data.yml/sequence_data/readgroup"
                                },
                                {
                                    "type": [
                                        {
                                            "type": "record",
                                            "name": "#sequence_data.yml/sequence_data/sequence/bam",
                                            "fields": [
                                                {
                                                    "type": "File",
                                                    "name": "#sequence_data.yml/sequence_data/sequence/bam/bam"
                                                }
                                            ]
                                        },
                                        {
                                            "type": "record",
                                            "name": "#sequence_data.yml/sequence_data/sequence/fastqs",
                                            "fields": [
                                                {
                                                    "type": "File",
                                                    "name": "#sequence_data.yml/sequence_data/sequence/fastqs/fastq1"
                                                },
                                                {
                                                    "type": "File",
                                                    "name": "#sequence_data.yml/sequence_data/sequence/fastqs/fastq2"
                                                }
                                            ]
                                        }
                                    ],
                                    "name": "#sequence_data.yml/sequence_data/sequence"
                                }
                            ]
                        }
                    ]
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "id": "#alignment_wgs.cwl/bqsr_intervals"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#alignment_wgs.cwl/dbsnp_vcf"
                },
                {
                    "type": "File",
                    "id": "#alignment_wgs.cwl/intervals"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#alignment_wgs.cwl/known_indels"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#alignment_wgs.cwl/mills"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#alignment_wgs.cwl/minimum_base_quality"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#alignment_wgs.cwl/minimum_mapping_quality"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#alignment_wgs.cwl/omni_vcf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#alignment_wgs.cwl/per_base_intervals"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#alignment_wgs.cwl/per_target_intervals"
                },
                {
                    "type": "string",
                    "id": "#alignment_wgs.cwl/picard_metric_accumulation_level"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict",
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ],
                    "id": "#alignment_wgs.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#alignment_wgs.cwl/sample_name"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#sequence_data.yml/sequence_data"
                    },
                    "id": "#alignment_wgs.cwl/sequence"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#alignment_wgs.cwl/summary_intervals"
                }
            ],
            "steps": [
                {
                    "run": "#sequence_to_bqsr.cwl",
                    "in": [
                        {
                            "source": "#alignment_wgs.cwl/bqsr_intervals",
                            "id": "#alignment_wgs.cwl/alignment/bqsr_intervals"
                        },
                        {
                            "source": "#alignment_wgs.cwl/dbsnp_vcf",
                            "id": "#alignment_wgs.cwl/alignment/dbsnp_vcf"
                        },
                        {
                            "source": "#alignment_wgs.cwl/sample_name",
                            "id": "#alignment_wgs.cwl/alignment/final_name"
                        },
                        {
                            "source": "#alignment_wgs.cwl/known_indels",
                            "id": "#alignment_wgs.cwl/alignment/known_indels"
                        },
                        {
                            "source": "#alignment_wgs.cwl/mills",
                            "id": "#alignment_wgs.cwl/alignment/mills"
                        },
                        {
                            "source": "#alignment_wgs.cwl/reference",
                            "id": "#alignment_wgs.cwl/alignment/reference"
                        },
                        {
                            "source": "#alignment_wgs.cwl/sequence",
                            "id": "#alignment_wgs.cwl/alignment/unaligned"
                        }
                    ],
                    "out": [
                        "#alignment_wgs.cwl/alignment/final_bam",
                        "#alignment_wgs.cwl/alignment/mark_duplicates_metrics_file"
                    ],
                    "id": "#alignment_wgs.cwl/alignment"
                },
                {
                    "run": "#qc_wgs.cwl",
                    "in": [
                        {
                            "source": "#alignment_wgs.cwl/alignment/final_bam",
                            "id": "#alignment_wgs.cwl/qc/bam"
                        },
                        {
                            "source": "#alignment_wgs.cwl/intervals",
                            "id": "#alignment_wgs.cwl/qc/intervals"
                        },
                        {
                            "source": "#alignment_wgs.cwl/minimum_base_quality",
                            "id": "#alignment_wgs.cwl/qc/minimum_base_quality"
                        },
                        {
                            "source": "#alignment_wgs.cwl/minimum_mapping_quality",
                            "id": "#alignment_wgs.cwl/qc/minimum_mapping_quality"
                        },
                        {
                            "source": "#alignment_wgs.cwl/omni_vcf",
                            "id": "#alignment_wgs.cwl/qc/omni_vcf"
                        },
                        {
                            "source": "#alignment_wgs.cwl/per_base_intervals",
                            "id": "#alignment_wgs.cwl/qc/per_base_intervals"
                        },
                        {
                            "source": "#alignment_wgs.cwl/per_target_intervals",
                            "id": "#alignment_wgs.cwl/qc/per_target_intervals"
                        },
                        {
                            "source": "#alignment_wgs.cwl/picard_metric_accumulation_level",
                            "id": "#alignment_wgs.cwl/qc/picard_metric_accumulation_level"
                        },
                        {
                            "source": "#alignment_wgs.cwl/reference",
                            "id": "#alignment_wgs.cwl/qc/reference"
                        },
                        {
                            "source": "#alignment_wgs.cwl/sample_name",
                            "id": "#alignment_wgs.cwl/qc/sample_name"
                        },
                        {
                            "source": "#alignment_wgs.cwl/summary_intervals",
                            "id": "#alignment_wgs.cwl/qc/summary_intervals"
                        }
                    ],
                    "out": [
                        "#alignment_wgs.cwl/qc/insert_size_metrics",
                        "#alignment_wgs.cwl/qc/insert_size_histogram",
                        "#alignment_wgs.cwl/qc/alignment_summary_metrics",
                        "#alignment_wgs.cwl/qc/gc_bias_metrics",
                        "#alignment_wgs.cwl/qc/gc_bias_metrics_chart",
                        "#alignment_wgs.cwl/qc/gc_bias_metrics_summary",
                        "#alignment_wgs.cwl/qc/wgs_metrics",
                        "#alignment_wgs.cwl/qc/flagstats",
                        "#alignment_wgs.cwl/qc/verify_bam_id_metrics",
                        "#alignment_wgs.cwl/qc/verify_bam_id_depth",
                        "#alignment_wgs.cwl/qc/per_base_coverage_metrics",
                        "#alignment_wgs.cwl/qc/per_base_hs_metrics",
                        "#alignment_wgs.cwl/qc/per_target_coverage_metrics",
                        "#alignment_wgs.cwl/qc/per_target_hs_metrics",
                        "#alignment_wgs.cwl/qc/summary_hs_metrics"
                    ],
                    "id": "#alignment_wgs.cwl/qc"
                }
            ],
            "id": "#alignment_wgs.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/qc/alignment_summary_metrics",
                    "id": "#alignment_wgs.cwl/alignment_summary_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/alignment/final_bam",
                    "id": "#alignment_wgs.cwl/bam"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/qc/flagstats",
                    "id": "#alignment_wgs.cwl/flagstats"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/qc/gc_bias_metrics",
                    "id": "#alignment_wgs.cwl/gc_bias_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/qc/gc_bias_metrics_chart",
                    "id": "#alignment_wgs.cwl/gc_bias_metrics_chart"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/qc/gc_bias_metrics_summary",
                    "id": "#alignment_wgs.cwl/gc_bias_metrics_summary"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/qc/insert_size_histogram",
                    "id": "#alignment_wgs.cwl/insert_size_histogram"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/qc/insert_size_metrics",
                    "id": "#alignment_wgs.cwl/insert_size_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/alignment/mark_duplicates_metrics_file",
                    "id": "#alignment_wgs.cwl/mark_duplicates_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#alignment_wgs.cwl/qc/per_base_coverage_metrics",
                    "id": "#alignment_wgs.cwl/per_base_coverage_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#alignment_wgs.cwl/qc/per_base_hs_metrics",
                    "id": "#alignment_wgs.cwl/per_base_hs_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#alignment_wgs.cwl/qc/per_target_coverage_metrics",
                    "id": "#alignment_wgs.cwl/per_target_coverage_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#alignment_wgs.cwl/qc/per_target_hs_metrics",
                    "id": "#alignment_wgs.cwl/per_target_hs_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#alignment_wgs.cwl/qc/summary_hs_metrics",
                    "id": "#alignment_wgs.cwl/summary_hs_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/qc/verify_bam_id_depth",
                    "id": "#alignment_wgs.cwl/verify_bam_id_depth"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/qc/verify_bam_id_metrics",
                    "id": "#alignment_wgs.cwl/verify_bam_id_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#alignment_wgs.cwl/qc/wgs_metrics",
                    "id": "#alignment_wgs.cwl/wgs_metrics"
                }
            ]
        },
        {
            "class": "Workflow",
            "label": "wgs alignment and germline variant detection",
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#labelled_file.yml/labelled_file"
                        },
                        {
                            "$import": "#sequence_data.yml/sequence_data"
                        },
                        {
                            "type": "record",
                            "name": "#vep_custom_annotation.yml/vep_custom_annotation",
                            "label": "custom annotation file to be used by vep",
                            "fields": [
                                {
                                    "type": {
                                        "type": "record",
                                        "name": "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info",
                                        "fields": [
                                            {
                                                "type": "boolean",
                                                "label": "Identify known variants colocated with input variant",
                                                "name": "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/check_existing"
                                            },
                                            {
                                                "type": {
                                                    "type": "enum",
                                                    "name": "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/data_format/format",
                                                    "symbols": [
                                                        "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/data_format/format/bed",
                                                        "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/data_format/format/gff",
                                                        "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/data_format/format/gtf",
                                                        "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/data_format/format/vcf",
                                                        "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/data_format/format/bigwig"
                                                    ],
                                                    "label": "Annotation file type"
                                                },
                                                "name": "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/data_format"
                                            },
                                            {
                                                "type": "File",
                                                "label": "File to be used for annotation, include index file",
                                                "name": "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/file"
                                            },
                                            {
                                                "type": [
                                                    "null",
                                                    "boolean"
                                                ],
                                                "label": "Use this annotation for gnomad filtering?",
                                                "name": "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/gnomad_filter"
                                            },
                                            {
                                                "type": "string",
                                                "label": "Used as key for new VEP annotation",
                                                "name": "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/name"
                                            },
                                            {
                                                "type": [
                                                    "null",
                                                    {
                                                        "type": "array",
                                                        "items": "string"
                                                    }
                                                ],
                                                "label": "List of VCF fields to annotate",
                                                "name": "#vep_custom_annotation.yml/vep_custom_annotation/annotation/info/vcf_fields"
                                            }
                                        ]
                                    },
                                    "name": "#vep_custom_annotation.yml/vep_custom_annotation/annotation"
                                },
                                {
                                    "type": "boolean",
                                    "label": "Force report the overlapping coordinates of custom feature instead of based on the exact coordinates",
                                    "name": "#vep_custom_annotation.yml/vep_custom_annotation/force_report_coordinates"
                                },
                                {
                                    "type": [
                                        {
                                            "type": "enum",
                                            "symbols": [
                                                "#vep_custom_annotation.yml/vep_custom_annotation/method/exact",
                                                "#vep_custom_annotation.yml/vep_custom_annotation/method/overlap"
                                            ],
                                            "label": "Require exact or overlap to annotate variants"
                                        }
                                    ],
                                    "name": "#vep_custom_annotation.yml/vep_custom_annotation/method"
                                }
                            ]
                        }
                    ]
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/annotate_coding_only"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "id": "#main/bqsr_intervals"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#main/cnv_filter_deletion_depth"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#main/cnv_filter_duplication_depth"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/cnv_filter_min_size"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/cnvkit_diagram"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/cnvkit_drop_low_coverage"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/cnvkit_male_reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/cnvkit_method"
                },
                {
                    "type": "File",
                    "id": "#main/cnvkit_reference_cnn"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/cnvkit_scatter_plot"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/cnvkit_vcf_name"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/dbsnp_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "Workflow source can be found at https://github.com/genome/analysis-workflows",
                    "id": "#main/disclaimer_text"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#main/emit_reference_confidence/NONE",
                            "#main/emit_reference_confidence/BP_RESOLUTION",
                            "#main/emit_reference_confidence/GVCF"
                        ]
                    },
                    "id": "#main/emit_reference_confidence"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/gvcf_gq_bands"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "string"
                        }
                    },
                    "id": "#main/intervals"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/known_indels"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/manta_call_regions"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/manta_non_wgs"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/manta_output_contigs"
                },
                {
                    "type": "boolean",
                    "id": "#main/merge_estimate_sv_distance"
                },
                {
                    "type": "int",
                    "id": "#main/merge_max_distance"
                },
                {
                    "type": "int",
                    "id": "#main/merge_min_sv_size"
                },
                {
                    "type": "int",
                    "id": "#main/merge_min_svs"
                },
                {
                    "type": "boolean",
                    "id": "#main/merge_same_strand"
                },
                {
                    "type": "boolean",
                    "id": "#main/merge_same_type"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/mills"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/minimum_base_quality"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/minimum_mapping_quality"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/omni_vcf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#main/per_base_intervals"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#main/per_target_intervals"
                },
                {
                    "type": "string",
                    "id": "#main/picard_metric_accumulation_level"
                },
                {
                    "type": "File",
                    "id": "#main/qc_intervals"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict",
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ],
                    "id": "#main/reference"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#sequence_data.yml/sequence_data"
                    },
                    "id": "#main/sequence"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/smoove_exclude_regions"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#main/summary_intervals"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#main/sv_filter_alt_abundance_percentage"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/sv_filter_paired_count"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/sv_filter_split_count"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/synonyms_file"
                },
                {
                    "type": "File",
                    "id": "#main/variant_reporting_intervals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "id": "#main/variants_to_table_fields"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "id": "#main/variants_to_table_genotype_fields"
                },
                {
                    "type": "string",
                    "id": "#main/vep_cache_dir"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#vep_custom_annotation.yml/vep_custom_annotation"
                    },
                    "doc": "custom type, check types directory for input format",
                    "id": "#main/vep_custom_annotations"
                },
                {
                    "type": "string",
                    "doc": "genome assembly to use in vep. Examples: GRCh38 or GRCm38",
                    "id": "#main/vep_ensembl_assembly"
                },
                {
                    "type": "string",
                    "doc": "ensembl species - Must be present in the cache directory. Examples: homo_sapiens or mus_musculus",
                    "id": "#main/vep_ensembl_species"
                },
                {
                    "type": "string",
                    "doc": "ensembl version - Must be present in the cache directory. Example: 95",
                    "id": "#main/vep_ensembl_version"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "array of plugins to use when running vep",
                    "id": "#main/vep_plugins"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "id": "#main/vep_to_table_fields"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/alignment_summary_metrics",
                    "id": "#main/alignment_summary_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#main/add_disclaimer_bcftools_sv_tsv/output_file",
                    "id": "#main/bcftools_merged_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#main/add_disclaimer_bcftools_filtered_sv_tsv/output_file",
                    "id": "#main/bcftools_merged_filtered_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#main/add_disclaimer_bcftools_sv_vcf/output_file",
                    "id": "#main/bcftools_merged_vcf"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/sv_detect_variants/cn_diagram",
                    "id": "#main/cn_diagram"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/sv_detect_variants/cn_scatter_plot",
                    "id": "#main/cn_scatter_plot"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/cnvkit_filtered_vcf",
                    "id": "#main/cnvkit_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/cnvkit_vcf",
                    "id": "#main/cnvkit_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/cnvnator_cn_file",
                    "id": "#main/cnvnator_cn_file"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/cnvnator_filtered_vcf",
                    "id": "#main/cnvnator_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/cnvnator_root",
                    "id": "#main/cnvnator_root"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/cnvnator_vcf",
                    "id": "#main/cnvnator_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/index_cram/indexed_cram",
                    "id": "#main/cram"
                },
                {
                    "type": "File",
                    "outputSource": "#main/add_disclaimer_filtered_tsv/output_file",
                    "id": "#main/filtered_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#main/index_disclaimer_filtered_vcf/indexed_vcf",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/add_disclaimer_final_tsv/output_file",
                    "id": "#main/final_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#main/index_disclaimer_final_vcf/indexed_vcf",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/final_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/flagstats",
                    "id": "#main/flagstats"
                },
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/gc_bias_metrics",
                    "id": "#main/gc_bias_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/gc_bias_metrics_chart",
                    "id": "#main/gc_bias_metrics_chart"
                },
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/gc_bias_metrics_summary",
                    "id": "#main/gc_bias_metrics_summary"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/detect_variants/gvcf",
                    "id": "#main/gvcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/insert_size_histogram",
                    "id": "#main/insert_size_histogram"
                },
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/insert_size_metrics",
                    "id": "#main/insert_size_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/manta_all_candidates",
                    "id": "#main/manta_all_candidates"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/sv_detect_variants/manta_diploid_variants",
                    "id": "#main/manta_diploid_variants"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/manta_filtered_vcf",
                    "id": "#main/manta_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/manta_small_candidates",
                    "id": "#main/manta_small_candidates"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/sv_detect_variants/manta_somatic_variants",
                    "id": "#main/manta_somatic_variants"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/sv_detect_variants/manta_tumor_only_variants",
                    "id": "#main/manta_tumor_only_variants"
                },
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/mark_duplicates_metrics",
                    "id": "#main/mark_duplicates_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/alignment_and_qc/per_base_coverage_metrics",
                    "id": "#main/per_base_coverage_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/alignment_and_qc/per_base_hs_metrics",
                    "id": "#main/per_base_hs_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/alignment_and_qc/per_target_coverage_metrics",
                    "id": "#main/per_target_coverage_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/alignment_and_qc/per_target_hs_metrics",
                    "id": "#main/per_target_hs_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/smoove_filtered_vcf",
                    "id": "#main/smoove_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/smoove_output_variants",
                    "id": "#main/smoove_output_variants"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/alignment_and_qc/summary_hs_metrics",
                    "id": "#main/summary_hs_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#main/add_disclaimer_survivor_sv_tsv/output_file",
                    "id": "#main/survivor_merged_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#main/add_disclaimer_survivor_sv_vcf/output_file",
                    "id": "#main/survivor_merged_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/tumor_antitarget_coverage",
                    "id": "#main/tumor_antitarget_coverage"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/tumor_bin_level_ratios",
                    "id": "#main/tumor_bin_level_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/tumor_segmented_ratios",
                    "id": "#main/tumor_segmented_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sv_detect_variants/tumor_target_coverage",
                    "id": "#main/tumor_target_coverage"
                },
                {
                    "type": "File",
                    "outputSource": "#main/detect_variants/vep_summary",
                    "id": "#main/vep_summary"
                },
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/verify_bam_id_depth",
                    "id": "#main/verify_bam_id_depth"
                },
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/verify_bam_id_metrics",
                    "id": "#main/verify_bam_id_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#main/alignment_and_qc/wgs_metrics",
                    "id": "#main/wgs_metrics"
                }
            ],
            "steps": [
                {
                    "run": "#add_string_at_line.cwl",
                    "in": [
                        {
                            "source": "#main/sv_detect_variants/bcftools_merged_filtered_annotated_tsv",
                            "id": "#main/add_disclaimer_bcftools_filtered_sv_tsv/input_file"
                        },
                        {
                            "default": 1,
                            "id": "#main/add_disclaimer_bcftools_filtered_sv_tsv/line_number"
                        },
                        {
                            "source": "#main/sv_detect_variants/bcftools_merged_filtered_annotated_tsv",
                            "valueFrom": "$(self.basename)",
                            "id": "#main/add_disclaimer_bcftools_filtered_sv_tsv/output_name"
                        },
                        {
                            "source": "#main/disclaimer_text",
                            "valueFrom": "#$(self)",
                            "id": "#main/add_disclaimer_bcftools_filtered_sv_tsv/some_text"
                        }
                    ],
                    "out": [
                        "#main/add_disclaimer_bcftools_filtered_sv_tsv/output_file"
                    ],
                    "id": "#main/add_disclaimer_bcftools_filtered_sv_tsv"
                },
                {
                    "run": "#add_string_at_line.cwl",
                    "in": [
                        {
                            "source": "#main/sv_detect_variants/bcftools_merged_annotated_tsv",
                            "id": "#main/add_disclaimer_bcftools_sv_tsv/input_file"
                        },
                        {
                            "default": 1,
                            "id": "#main/add_disclaimer_bcftools_sv_tsv/line_number"
                        },
                        {
                            "source": "#main/sv_detect_variants/bcftools_merged_annotated_tsv",
                            "valueFrom": "$(self.basename)",
                            "id": "#main/add_disclaimer_bcftools_sv_tsv/output_name"
                        },
                        {
                            "source": "#main/disclaimer_text",
                            "valueFrom": "#$(self)",
                            "id": "#main/add_disclaimer_bcftools_sv_tsv/some_text"
                        }
                    ],
                    "out": [
                        "#main/add_disclaimer_bcftools_sv_tsv/output_file"
                    ],
                    "id": "#main/add_disclaimer_bcftools_sv_tsv"
                },
                {
                    "run": "#add_string_at_line_bgzipped.cwl",
                    "in": [
                        {
                            "source": "#main/sv_detect_variants/bcftools_merged_vcf",
                            "id": "#main/add_disclaimer_bcftools_sv_vcf/input_file"
                        },
                        {
                            "default": 2,
                            "id": "#main/add_disclaimer_bcftools_sv_vcf/line_number"
                        },
                        {
                            "source": "#main/sv_detect_variants/bcftools_merged_vcf",
                            "valueFrom": "$(self.basename)",
                            "id": "#main/add_disclaimer_bcftools_sv_vcf/output_name"
                        },
                        {
                            "source": "#main/disclaimer_text",
                            "valueFrom": "##disclaimer=$(self)",
                            "id": "#main/add_disclaimer_bcftools_sv_vcf/some_text"
                        }
                    ],
                    "out": [
                        "#main/add_disclaimer_bcftools_sv_vcf/output_file"
                    ],
                    "id": "#main/add_disclaimer_bcftools_sv_vcf"
                },
                {
                    "run": "#add_string_at_line.cwl",
                    "in": [
                        {
                            "source": "#main/detect_variants/filtered_tsv",
                            "id": "#main/add_disclaimer_filtered_tsv/input_file"
                        },
                        {
                            "default": 1,
                            "id": "#main/add_disclaimer_filtered_tsv/line_number"
                        },
                        {
                            "source": "#main/detect_variants/filtered_tsv",
                            "valueFrom": "$(self.basename)",
                            "id": "#main/add_disclaimer_filtered_tsv/output_name"
                        },
                        {
                            "source": "#main/disclaimer_text",
                            "valueFrom": "#$(self)",
                            "id": "#main/add_disclaimer_filtered_tsv/some_text"
                        }
                    ],
                    "out": [
                        "#main/add_disclaimer_filtered_tsv/output_file"
                    ],
                    "id": "#main/add_disclaimer_filtered_tsv"
                },
                {
                    "run": "#add_string_at_line_bgzipped.cwl",
                    "in": [
                        {
                            "source": "#main/detect_variants/filtered_vcf",
                            "id": "#main/add_disclaimer_filtered_vcf/input_file"
                        },
                        {
                            "default": 2,
                            "id": "#main/add_disclaimer_filtered_vcf/line_number"
                        },
                        {
                            "source": "#main/detect_variants/filtered_vcf",
                            "valueFrom": "$(self.basename)",
                            "id": "#main/add_disclaimer_filtered_vcf/output_name"
                        },
                        {
                            "source": "#main/disclaimer_text",
                            "valueFrom": "##disclaimer=$(self)",
                            "id": "#main/add_disclaimer_filtered_vcf/some_text"
                        }
                    ],
                    "out": [
                        "#main/add_disclaimer_filtered_vcf/output_file"
                    ],
                    "id": "#main/add_disclaimer_filtered_vcf"
                },
                {
                    "run": "#add_string_at_line.cwl",
                    "in": [
                        {
                            "source": "#main/detect_variants/final_tsv",
                            "id": "#main/add_disclaimer_final_tsv/input_file"
                        },
                        {
                            "default": 1,
                            "id": "#main/add_disclaimer_final_tsv/line_number"
                        },
                        {
                            "source": "#main/detect_variants/final_tsv",
                            "valueFrom": "$(self.basename)",
                            "id": "#main/add_disclaimer_final_tsv/output_name"
                        },
                        {
                            "source": "#main/disclaimer_text",
                            "valueFrom": "#$(self)",
                            "id": "#main/add_disclaimer_final_tsv/some_text"
                        }
                    ],
                    "out": [
                        "#main/add_disclaimer_final_tsv/output_file"
                    ],
                    "id": "#main/add_disclaimer_final_tsv"
                },
                {
                    "run": "#add_string_at_line_bgzipped.cwl",
                    "in": [
                        {
                            "source": "#main/detect_variants/final_vcf",
                            "id": "#main/add_disclaimer_final_vcf/input_file"
                        },
                        {
                            "default": 2,
                            "id": "#main/add_disclaimer_final_vcf/line_number"
                        },
                        {
                            "source": "#main/detect_variants/final_vcf",
                            "valueFrom": "$(self.basename)",
                            "id": "#main/add_disclaimer_final_vcf/output_name"
                        },
                        {
                            "source": "#main/disclaimer_text",
                            "valueFrom": "##disclaimer=$(self)",
                            "id": "#main/add_disclaimer_final_vcf/some_text"
                        }
                    ],
                    "out": [
                        "#main/add_disclaimer_final_vcf/output_file"
                    ],
                    "id": "#main/add_disclaimer_final_vcf"
                },
                {
                    "run": "#add_string_at_line.cwl",
                    "in": [
                        {
                            "source": "#main/sv_detect_variants/survivor_merged_annotated_tsv",
                            "id": "#main/add_disclaimer_survivor_sv_tsv/input_file"
                        },
                        {
                            "default": 1,
                            "id": "#main/add_disclaimer_survivor_sv_tsv/line_number"
                        },
                        {
                            "source": "#main/sv_detect_variants/survivor_merged_annotated_tsv",
                            "valueFrom": "$(self.basename)",
                            "id": "#main/add_disclaimer_survivor_sv_tsv/output_name"
                        },
                        {
                            "source": "#main/disclaimer_text",
                            "valueFrom": "#$(self)",
                            "id": "#main/add_disclaimer_survivor_sv_tsv/some_text"
                        }
                    ],
                    "out": [
                        "#main/add_disclaimer_survivor_sv_tsv/output_file"
                    ],
                    "id": "#main/add_disclaimer_survivor_sv_tsv"
                },
                {
                    "run": "#add_string_at_line_bgzipped.cwl",
                    "in": [
                        {
                            "source": "#main/sv_detect_variants/survivor_merged_vcf",
                            "id": "#main/add_disclaimer_survivor_sv_vcf/input_file"
                        },
                        {
                            "default": 2,
                            "id": "#main/add_disclaimer_survivor_sv_vcf/line_number"
                        },
                        {
                            "source": "#main/sv_detect_variants/survivor_merged_vcf",
                            "valueFrom": "$(self.basename)",
                            "id": "#main/add_disclaimer_survivor_sv_vcf/output_name"
                        },
                        {
                            "source": "#main/disclaimer_text",
                            "valueFrom": "##disclaimer=$(self)",
                            "id": "#main/add_disclaimer_survivor_sv_vcf/some_text"
                        }
                    ],
                    "out": [
                        "#main/add_disclaimer_survivor_sv_vcf/output_file"
                    ],
                    "id": "#main/add_disclaimer_survivor_sv_vcf"
                },
                {
                    "run": "#alignment_wgs.cwl",
                    "in": [
                        {
                            "source": "#main/bqsr_intervals",
                            "id": "#main/alignment_and_qc/bqsr_intervals"
                        },
                        {
                            "source": "#main/dbsnp_vcf",
                            "id": "#main/alignment_and_qc/dbsnp_vcf"
                        },
                        {
                            "source": "#main/qc_intervals",
                            "id": "#main/alignment_and_qc/intervals"
                        },
                        {
                            "source": "#main/known_indels",
                            "id": "#main/alignment_and_qc/known_indels"
                        },
                        {
                            "source": "#main/mills",
                            "id": "#main/alignment_and_qc/mills"
                        },
                        {
                            "source": "#main/minimum_base_quality",
                            "id": "#main/alignment_and_qc/minimum_base_quality"
                        },
                        {
                            "source": "#main/minimum_mapping_quality",
                            "id": "#main/alignment_and_qc/minimum_mapping_quality"
                        },
                        {
                            "source": "#main/omni_vcf",
                            "id": "#main/alignment_and_qc/omni_vcf"
                        },
                        {
                            "source": "#main/per_base_intervals",
                            "id": "#main/alignment_and_qc/per_base_intervals"
                        },
                        {
                            "source": "#main/per_target_intervals",
                            "id": "#main/alignment_and_qc/per_target_intervals"
                        },
                        {
                            "source": "#main/picard_metric_accumulation_level",
                            "id": "#main/alignment_and_qc/picard_metric_accumulation_level"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/alignment_and_qc/reference"
                        },
                        {
                            "source": "#main/sequence",
                            "id": "#main/alignment_and_qc/sequence"
                        },
                        {
                            "source": "#main/summary_intervals",
                            "id": "#main/alignment_and_qc/summary_intervals"
                        }
                    ],
                    "out": [
                        "#main/alignment_and_qc/bam",
                        "#main/alignment_and_qc/mark_duplicates_metrics",
                        "#main/alignment_and_qc/insert_size_metrics",
                        "#main/alignment_and_qc/insert_size_histogram",
                        "#main/alignment_and_qc/alignment_summary_metrics",
                        "#main/alignment_and_qc/gc_bias_metrics",
                        "#main/alignment_and_qc/gc_bias_metrics_chart",
                        "#main/alignment_and_qc/gc_bias_metrics_summary",
                        "#main/alignment_and_qc/wgs_metrics",
                        "#main/alignment_and_qc/flagstats",
                        "#main/alignment_and_qc/verify_bam_id_metrics",
                        "#main/alignment_and_qc/verify_bam_id_depth",
                        "#main/alignment_and_qc/per_base_coverage_metrics",
                        "#main/alignment_and_qc/per_base_hs_metrics",
                        "#main/alignment_and_qc/per_target_coverage_metrics",
                        "#main/alignment_and_qc/per_target_hs_metrics",
                        "#main/alignment_and_qc/summary_hs_metrics"
                    ],
                    "id": "#main/alignment_and_qc"
                },
                {
                    "run": "#bam_to_cram.cwl",
                    "in": [
                        {
                            "source": "#main/alignment_and_qc/bam",
                            "id": "#main/bam_to_cram/bam"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/bam_to_cram/reference"
                        }
                    ],
                    "out": [
                        "#main/bam_to_cram/cram"
                    ],
                    "id": "#main/bam_to_cram"
                },
                {
                    "run": "#germline_detect_variants.cwl",
                    "in": [
                        {
                            "source": "#main/annotate_coding_only",
                            "id": "#main/detect_variants/annotate_coding_only"
                        },
                        {
                            "source": "#main/alignment_and_qc/bam",
                            "id": "#main/detect_variants/bam"
                        },
                        {
                            "source": "#main/extract_freemix/freemix_score",
                            "id": "#main/detect_variants/contamination_fraction"
                        },
                        {
                            "source": "#main/emit_reference_confidence",
                            "id": "#main/detect_variants/emit_reference_confidence"
                        },
                        {
                            "source": "#main/gvcf_gq_bands",
                            "id": "#main/detect_variants/gvcf_gq_bands"
                        },
                        {
                            "source": "#main/intervals",
                            "id": "#main/detect_variants/intervals"
                        },
                        {
                            "source": "#main/variant_reporting_intervals",
                            "id": "#main/detect_variants/limit_variant_intervals"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/detect_variants/reference"
                        },
                        {
                            "source": "#main/synonyms_file",
                            "id": "#main/detect_variants/synonyms_file"
                        },
                        {
                            "source": "#main/variants_to_table_fields",
                            "id": "#main/detect_variants/variants_to_table_fields"
                        },
                        {
                            "source": "#main/variants_to_table_genotype_fields",
                            "id": "#main/detect_variants/variants_to_table_genotype_fields"
                        },
                        {
                            "source": "#main/vep_cache_dir",
                            "id": "#main/detect_variants/vep_cache_dir"
                        },
                        {
                            "source": "#main/vep_custom_annotations",
                            "id": "#main/detect_variants/vep_custom_annotations"
                        },
                        {
                            "source": "#main/vep_ensembl_assembly",
                            "id": "#main/detect_variants/vep_ensembl_assembly"
                        },
                        {
                            "source": "#main/vep_ensembl_species",
                            "id": "#main/detect_variants/vep_ensembl_species"
                        },
                        {
                            "source": "#main/vep_ensembl_version",
                            "id": "#main/detect_variants/vep_ensembl_version"
                        },
                        {
                            "source": "#main/vep_plugins",
                            "id": "#main/detect_variants/vep_plugins"
                        },
                        {
                            "source": "#main/vep_to_table_fields",
                            "id": "#main/detect_variants/vep_to_table_fields"
                        }
                    ],
                    "out": [
                        "#main/detect_variants/gvcf",
                        "#main/detect_variants/final_vcf",
                        "#main/detect_variants/filtered_vcf",
                        "#main/detect_variants/vep_summary",
                        "#main/detect_variants/final_tsv",
                        "#main/detect_variants/filtered_tsv"
                    ],
                    "id": "#main/detect_variants"
                },
                {
                    "in": [
                        {
                            "source": "#main/alignment_and_qc/verify_bam_id_metrics",
                            "id": "#main/extract_freemix/verify_bam_id_metrics"
                        }
                    ],
                    "out": [
                        "#main/extract_freemix/freemix_score"
                    ],
                    "run": {
                        "class": "ExpressionTool",
                        "requirements": [
                            {
                                "class": "InlineJavascriptRequirement"
                            }
                        ],
                        "inputs": [
                            {
                                "type": "File",
                                "inputBinding": {
                                    "loadContents": true
                                },
                                "id": "#main/extract_freemix/fdcbde00-a7a8-4208-b48b-553fbd8d794d/verify_bam_id_metrics"
                            }
                        ],
                        "outputs": [
                            {
                                "type": [
                                    "null",
                                    "string"
                                ],
                                "id": "#main/extract_freemix/fdcbde00-a7a8-4208-b48b-553fbd8d794d/freemix_score"
                            }
                        ],
                        "expression": "${\n    var metrics = inputs.verify_bam_id_metrics.contents.split(\"\\n\");\n    if ( metrics[0].split(\"\\t\")[6] == 'FREEMIX' ) {\n        return {'freemix_score': metrics[1].split(\"\\t\")[6]};\n    } else {\n        return {'freemix_score:': null };\n    }\n}\n",
                        "id": "#main/extract_freemix/fdcbde00-a7a8-4208-b48b-553fbd8d794d"
                    },
                    "id": "#main/extract_freemix"
                },
                {
                    "run": "#index_cram.cwl",
                    "in": [
                        {
                            "source": "#main/bam_to_cram/cram",
                            "id": "#main/index_cram/cram"
                        }
                    ],
                    "out": [
                        "#main/index_cram/indexed_cram"
                    ],
                    "id": "#main/index_cram"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#main/add_disclaimer_filtered_vcf/output_file",
                            "id": "#main/index_disclaimer_filtered_vcf/vcf"
                        }
                    ],
                    "out": [
                        "#main/index_disclaimer_filtered_vcf/indexed_vcf"
                    ],
                    "id": "#main/index_disclaimer_filtered_vcf"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#main/add_disclaimer_final_vcf/output_file",
                            "id": "#main/index_disclaimer_final_vcf/vcf"
                        }
                    ],
                    "out": [
                        "#main/index_disclaimer_final_vcf/indexed_vcf"
                    ],
                    "id": "#main/index_disclaimer_final_vcf"
                },
                {
                    "run": "#single_sample_sv_callers.cwl",
                    "in": [
                        {
                            "source": "#main/alignment_and_qc/bam",
                            "id": "#main/sv_detect_variants/bam"
                        },
                        {
                            "source": "#main/cnv_filter_deletion_depth",
                            "id": "#main/sv_detect_variants/cnv_deletion_depth"
                        },
                        {
                            "source": "#main/cnv_filter_duplication_depth",
                            "id": "#main/sv_detect_variants/cnv_duplication_depth"
                        },
                        {
                            "source": "#main/cnv_filter_min_size",
                            "id": "#main/sv_detect_variants/cnv_filter_min_size"
                        },
                        {
                            "source": "#main/cnvkit_diagram",
                            "id": "#main/sv_detect_variants/cnvkit_diagram"
                        },
                        {
                            "source": "#main/cnvkit_drop_low_coverage",
                            "id": "#main/sv_detect_variants/cnvkit_drop_low_coverage"
                        },
                        {
                            "source": "#main/cnvkit_male_reference",
                            "id": "#main/sv_detect_variants/cnvkit_male_reference"
                        },
                        {
                            "source": "#main/cnvkit_method",
                            "id": "#main/sv_detect_variants/cnvkit_method"
                        },
                        {
                            "source": "#main/cnvkit_reference_cnn",
                            "id": "#main/sv_detect_variants/cnvkit_reference_cnn"
                        },
                        {
                            "source": "#main/cnvkit_scatter_plot",
                            "id": "#main/sv_detect_variants/cnvkit_scatter_plot"
                        },
                        {
                            "source": "#main/cnvkit_vcf_name",
                            "id": "#main/sv_detect_variants/cnvkit_vcf_name"
                        },
                        {
                            "source": "#main/vep_ensembl_assembly",
                            "id": "#main/sv_detect_variants/genome_build"
                        },
                        {
                            "source": "#main/manta_call_regions",
                            "id": "#main/sv_detect_variants/manta_call_regions"
                        },
                        {
                            "source": "#main/manta_non_wgs",
                            "id": "#main/sv_detect_variants/manta_non_wgs"
                        },
                        {
                            "source": "#main/manta_output_contigs",
                            "id": "#main/sv_detect_variants/manta_output_contigs"
                        },
                        {
                            "source": "#main/merge_estimate_sv_distance",
                            "id": "#main/sv_detect_variants/merge_estimate_sv_distance"
                        },
                        {
                            "source": "#main/merge_max_distance",
                            "id": "#main/sv_detect_variants/merge_max_distance"
                        },
                        {
                            "source": "#main/merge_min_sv_size",
                            "id": "#main/sv_detect_variants/merge_min_sv_size"
                        },
                        {
                            "source": "#main/merge_min_svs",
                            "id": "#main/sv_detect_variants/merge_min_svs"
                        },
                        {
                            "source": "#main/merge_same_strand",
                            "id": "#main/sv_detect_variants/merge_same_strand"
                        },
                        {
                            "source": "#main/merge_same_type",
                            "id": "#main/sv_detect_variants/merge_same_type"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/sv_detect_variants/reference"
                        },
                        {
                            "source": "#main/smoove_exclude_regions",
                            "id": "#main/sv_detect_variants/smoove_exclude_regions"
                        },
                        {
                            "source": "#main/detect_variants/final_vcf",
                            "id": "#main/sv_detect_variants/snps_vcf"
                        },
                        {
                            "source": "#main/sv_filter_alt_abundance_percentage",
                            "id": "#main/sv_detect_variants/sv_alt_abundance_percentage"
                        },
                        {
                            "source": "#main/sv_filter_paired_count",
                            "id": "#main/sv_detect_variants/sv_paired_count"
                        },
                        {
                            "source": "#main/sv_filter_split_count",
                            "id": "#main/sv_detect_variants/sv_split_count"
                        }
                    ],
                    "out": [
                        "#main/sv_detect_variants/cn_diagram",
                        "#main/sv_detect_variants/cn_scatter_plot",
                        "#main/sv_detect_variants/tumor_antitarget_coverage",
                        "#main/sv_detect_variants/tumor_target_coverage",
                        "#main/sv_detect_variants/tumor_bin_level_ratios",
                        "#main/sv_detect_variants/tumor_segmented_ratios",
                        "#main/sv_detect_variants/cnvkit_vcf",
                        "#main/sv_detect_variants/cnvnator_cn_file",
                        "#main/sv_detect_variants/cnvnator_root",
                        "#main/sv_detect_variants/cnvnator_vcf",
                        "#main/sv_detect_variants/manta_diploid_variants",
                        "#main/sv_detect_variants/manta_somatic_variants",
                        "#main/sv_detect_variants/manta_all_candidates",
                        "#main/sv_detect_variants/manta_small_candidates",
                        "#main/sv_detect_variants/manta_tumor_only_variants",
                        "#main/sv_detect_variants/smoove_output_variants",
                        "#main/sv_detect_variants/cnvkit_filtered_vcf",
                        "#main/sv_detect_variants/cnvnator_filtered_vcf",
                        "#main/sv_detect_variants/manta_filtered_vcf",
                        "#main/sv_detect_variants/smoove_filtered_vcf",
                        "#main/sv_detect_variants/survivor_merged_vcf",
                        "#main/sv_detect_variants/survivor_merged_annotated_tsv",
                        "#main/sv_detect_variants/bcftools_merged_vcf",
                        "#main/sv_detect_variants/bcftools_merged_annotated_tsv",
                        "#main/sv_detect_variants/bcftools_merged_filtered_annotated_tsv"
                    ],
                    "id": "#main/sv_detect_variants"
                }
            ],
            "id": "#main"
        },
        {
            "class": "Workflow",
            "label": "Subworkflow that runs cnvkit in single sample mode and returns a vcf file",
            "requirements": [
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "cnvkit.vcf",
                    "id": "#cnvkit_single_sample.cwl/cnvkit_vcf_name"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#cnvkit_single_sample.cwl/diagram"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#cnvkit_single_sample.cwl/drop_low_coverage"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#cnvkit_single_sample.cwl/male_reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "hybrid",
                    "id": "#cnvkit_single_sample.cwl/method"
                },
                {
                    "type": "File",
                    "id": "#cnvkit_single_sample.cwl/reference_cnn"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#cnvkit_single_sample.cwl/scatter_plot"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#cnvkit_single_sample.cwl/segment_filter/ampdel",
                                "#cnvkit_single_sample.cwl/segment_filter/ci",
                                "#cnvkit_single_sample.cwl/segment_filter/cn",
                                "#cnvkit_single_sample.cwl/segment_filter/sem"
                            ]
                        }
                    ],
                    "id": "#cnvkit_single_sample.cwl/segment_filter"
                },
                {
                    "type": "File",
                    "id": "#cnvkit_single_sample.cwl/tumor_bam"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/cn_diagram",
                    "id": "#cnvkit_single_sample.cwl/cn_diagram"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/cn_scatter_plot",
                    "id": "#cnvkit_single_sample.cwl/cn_scatter_plot"
                },
                {
                    "type": "File",
                    "outputSource": "#cnvkit_single_sample.cwl/cns_to_vcf/cnvkit_vcf",
                    "id": "#cnvkit_single_sample.cwl/cnvkit_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_antitarget_coverage",
                    "id": "#cnvkit_single_sample.cwl/tumor_antitarget_coverage"
                },
                {
                    "type": "File",
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_bin_level_ratios",
                    "id": "#cnvkit_single_sample.cwl/tumor_bin_level_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_segmented_ratios",
                    "id": "#cnvkit_single_sample.cwl/tumor_segmented_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_target_coverage",
                    "id": "#cnvkit_single_sample.cwl/tumor_target_coverage"
                }
            ],
            "steps": [
                {
                    "run": "#cnvkit_vcf_export.cwl",
                    "in": [
                        {
                            "source": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_bin_level_ratios",
                            "id": "#cnvkit_single_sample.cwl/cns_to_vcf/cnr_file"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_segmented_ratios",
                            "id": "#cnvkit_single_sample.cwl/cns_to_vcf/cns_file"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/male_reference",
                            "id": "#cnvkit_single_sample.cwl/cns_to_vcf/male_reference"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/cnvkit_vcf_name",
                            "id": "#cnvkit_single_sample.cwl/cns_to_vcf/output_name"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/segment_filter",
                            "id": "#cnvkit_single_sample.cwl/cns_to_vcf/segment_filter"
                        }
                    ],
                    "out": [
                        "#cnvkit_single_sample.cwl/cns_to_vcf/cnvkit_vcf"
                    ],
                    "id": "#cnvkit_single_sample.cwl/cns_to_vcf"
                },
                {
                    "run": "#cnvkit_batch.cwl",
                    "in": [
                        {
                            "source": "#cnvkit_single_sample.cwl/diagram",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/diagram"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/drop_low_coverage",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/drop_low_coverage"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/male_reference",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/male_reference"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/method",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/method"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/reference_cnn",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/reference_cnn"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/scatter_plot",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/scatter_plot"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/tumor_bam",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_bam"
                        }
                    ],
                    "out": [
                        "#cnvkit_single_sample.cwl/cnvkit_main/cn_diagram",
                        "#cnvkit_single_sample.cwl/cnvkit_main/cn_scatter_plot",
                        "#cnvkit_single_sample.cwl/cnvkit_main/tumor_antitarget_coverage",
                        "#cnvkit_single_sample.cwl/cnvkit_main/tumor_target_coverage",
                        "#cnvkit_single_sample.cwl/cnvkit_main/tumor_bin_level_ratios",
                        "#cnvkit_single_sample.cwl/cnvkit_main/tumor_segmented_ratios"
                    ],
                    "id": "#cnvkit_single_sample.cwl/cnvkit_main"
                }
            ],
            "id": "#cnvkit_single_sample.cwl"
        },
        {
            "class": "Workflow",
            "label": "scatter GATK HaplotypeCaller over intervals",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#gatk_haplotypecaller_iterator.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#gatk_haplotypecaller_iterator.cwl/contamination_fraction"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk_haplotypecaller_iterator.cwl/dbsnp_vcf"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#gatk_haplotypecaller_iterator.cwl/emit_reference_confidence/NONE",
                            "#gatk_haplotypecaller_iterator.cwl/emit_reference_confidence/BP_RESOLUTION",
                            "#gatk_haplotypecaller_iterator.cwl/emit_reference_confidence/GVCF"
                        ]
                    },
                    "id": "#gatk_haplotypecaller_iterator.cwl/emit_reference_confidence"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#gatk_haplotypecaller_iterator.cwl/gvcf_gq_bands"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "string"
                        }
                    },
                    "id": "#gatk_haplotypecaller_iterator.cwl/intervals"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#gatk_haplotypecaller_iterator.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/gvcf",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk_haplotypecaller_iterator.cwl/gvcf"
                }
            ],
            "steps": [
                {
                    "scatter": [
                        "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/intervals"
                    ],
                    "run": "#gatk_haplotype_caller.cwl",
                    "in": [
                        {
                            "source": "#gatk_haplotypecaller_iterator.cwl/bam",
                            "id": "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/bam"
                        },
                        {
                            "source": "#gatk_haplotypecaller_iterator.cwl/contamination_fraction",
                            "id": "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/contamination_fraction"
                        },
                        {
                            "source": "#gatk_haplotypecaller_iterator.cwl/dbsnp_vcf",
                            "id": "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/dbsnp_vcf"
                        },
                        {
                            "source": "#gatk_haplotypecaller_iterator.cwl/emit_reference_confidence",
                            "id": "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/emit_reference_confidence"
                        },
                        {
                            "source": "#gatk_haplotypecaller_iterator.cwl/gvcf_gq_bands",
                            "id": "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/gvcf_gq_bands"
                        },
                        {
                            "source": "#gatk_haplotypecaller_iterator.cwl/intervals",
                            "id": "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/intervals"
                        },
                        {
                            "valueFrom": "${ if (inputs.intervals.length == 1 && inputs.intervals[0].match(/^[0-9A-Za-z]+$/)) { return inputs.intervals[0] + \".g.vcf.gz\"; } else { return \"output.g.vcf.gz\"; } }",
                            "id": "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/output_file_name"
                        },
                        {
                            "source": "#gatk_haplotypecaller_iterator.cwl/reference",
                            "id": "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/reference"
                        }
                    ],
                    "out": [
                        "#gatk_haplotypecaller_iterator.cwl/haplotype_caller/gvcf"
                    ],
                    "id": "#gatk_haplotypecaller_iterator.cwl/haplotype_caller"
                }
            ],
            "id": "#gatk_haplotypecaller_iterator.cwl"
        },
        {
            "class": "Workflow",
            "label": "exome alignment and germline variant detection",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#vep_custom_annotation.yml/vep_custom_annotation"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#germline_detect_variants.cwl/annotate_coding_only"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#germline_detect_variants.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#germline_detect_variants.cwl/contamination_fraction"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#germline_detect_variants.cwl/emit_reference_confidence/NONE",
                            "#germline_detect_variants.cwl/emit_reference_confidence/BP_RESOLUTION",
                            "#germline_detect_variants.cwl/emit_reference_confidence/GVCF"
                        ]
                    },
                    "id": "#germline_detect_variants.cwl/emit_reference_confidence"
                },
                {
                    "type": "float",
                    "default": 0.05,
                    "id": "#germline_detect_variants.cwl/filter_gnomAD_maximum_population_allele_frequency"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "variants",
                    "id": "#germline_detect_variants.cwl/final_tsv_prefix"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#germline_detect_variants.cwl/gvcf_gq_bands"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "array",
                            "items": "string"
                        }
                    },
                    "id": "#germline_detect_variants.cwl/intervals"
                },
                {
                    "type": "File",
                    "id": "#germline_detect_variants.cwl/limit_variant_intervals"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#germline_detect_variants.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#germline_detect_variants.cwl/synonyms_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "default": [
                        "CHROM",
                        "POS",
                        "ID",
                        "REF",
                        "ALT"
                    ],
                    "id": "#germline_detect_variants.cwl/variants_to_table_fields"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "id": "#germline_detect_variants.cwl/variants_to_table_genotype_fields"
                },
                {
                    "type": "string",
                    "id": "#germline_detect_variants.cwl/vep_cache_dir"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#vep_custom_annotation.yml/vep_custom_annotation"
                    },
                    "doc": "custom type, check types directory for input format",
                    "id": "#germline_detect_variants.cwl/vep_custom_annotations"
                },
                {
                    "type": "string",
                    "doc": "genome assembly to use in vep. Examples: GRCh38 or GRCm38",
                    "id": "#germline_detect_variants.cwl/vep_ensembl_assembly"
                },
                {
                    "type": "string",
                    "doc": "ensembl species - Must be present in the cache directory. Examples: homo_sapiens or mus_musculus",
                    "id": "#germline_detect_variants.cwl/vep_ensembl_species"
                },
                {
                    "type": "string",
                    "doc": "ensembl version - Must be present in the cache directory. Example: 95",
                    "id": "#germline_detect_variants.cwl/vep_ensembl_version"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "default": [
                        "Downstream",
                        "Wildtype"
                    ],
                    "id": "#germline_detect_variants.cwl/vep_plugins"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "id": "#germline_detect_variants.cwl/vep_to_table_fields"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#germline_detect_variants.cwl/set_filtered_tsv_name/replacement",
                    "id": "#germline_detect_variants.cwl/filtered_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#germline_detect_variants.cwl/filter_vcf/filtered_vcf",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#germline_detect_variants.cwl/filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#germline_detect_variants.cwl/set_final_tsv_name/replacement",
                    "id": "#germline_detect_variants.cwl/final_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#germline_detect_variants.cwl/filter_vcf/final_vcf",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#germline_detect_variants.cwl/final_vcf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#germline_detect_variants.cwl/haplotype_caller/gvcf",
                    "id": "#germline_detect_variants.cwl/gvcf"
                },
                {
                    "type": "File",
                    "outputSource": "#germline_detect_variants.cwl/annotate_variants/vep_summary",
                    "id": "#germline_detect_variants.cwl/vep_summary"
                }
            ],
            "steps": [
                {
                    "run": "#vep.cwl",
                    "in": [
                        {
                            "source": "#germline_detect_variants.cwl/vep_cache_dir",
                            "id": "#germline_detect_variants.cwl/annotate_variants/cache_dir"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/annotate_coding_only",
                            "id": "#germline_detect_variants.cwl/annotate_variants/coding_only"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/vep_custom_annotations",
                            "id": "#germline_detect_variants.cwl/annotate_variants/custom_annotations"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/vep_ensembl_assembly",
                            "id": "#germline_detect_variants.cwl/annotate_variants/ensembl_assembly"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/vep_ensembl_species",
                            "id": "#germline_detect_variants.cwl/annotate_variants/ensembl_species"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/vep_ensembl_version",
                            "id": "#germline_detect_variants.cwl/annotate_variants/ensembl_version"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/vep_plugins",
                            "id": "#germline_detect_variants.cwl/annotate_variants/plugins"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/reference",
                            "id": "#germline_detect_variants.cwl/annotate_variants/reference"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/synonyms_file",
                            "id": "#germline_detect_variants.cwl/annotate_variants/synonyms_file"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/genotype_gvcfs/genotype_vcf",
                            "id": "#germline_detect_variants.cwl/annotate_variants/vcf"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/annotate_variants/annotated_vcf",
                        "#germline_detect_variants.cwl/annotate_variants/vep_summary"
                    ],
                    "id": "#germline_detect_variants.cwl/annotate_variants"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#germline_detect_variants.cwl/annotate_variants/annotated_vcf",
                            "id": "#germline_detect_variants.cwl/bgzip_annotated_vcf/file"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/bgzip_annotated_vcf/bgzipped_file"
                    ],
                    "id": "#germline_detect_variants.cwl/bgzip_annotated_vcf"
                },
                {
                    "run": "#germline_filter_vcf.cwl",
                    "in": [
                        {
                            "source": "#germline_detect_variants.cwl/annotate_variants/annotated_vcf",
                            "id": "#germline_detect_variants.cwl/filter_vcf/annotated_vcf"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/filter_gnomAD_maximum_population_allele_frequency",
                            "id": "#germline_detect_variants.cwl/filter_vcf/filter_gnomAD_maximum_population_allele_frequency"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/vep_custom_annotations",
                            "valueFrom": "${\n   if(self){\n        for(var i=0; i<self.length; i++){\n            if(self[i].annotation.gnomad_filter){\n                return(self[i].annotation.name + '_AF');\n            }\n        }\n    }\n    return('gnomAD_AF');\n}\n",
                            "id": "#germline_detect_variants.cwl/filter_vcf/gnomad_field_name"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/limit_variant_intervals",
                            "id": "#germline_detect_variants.cwl/filter_vcf/limit_variant_intervals"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/reference",
                            "id": "#germline_detect_variants.cwl/filter_vcf/reference"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/filter_vcf/filtered_vcf",
                        "#germline_detect_variants.cwl/filter_vcf/final_vcf"
                    ],
                    "id": "#germline_detect_variants.cwl/filter_vcf"
                },
                {
                    "run": "#add_vep_fields_to_table.cwl",
                    "in": [
                        {
                            "source": "#germline_detect_variants.cwl/final_tsv_prefix",
                            "id": "#germline_detect_variants.cwl/filtered_add_vep_fields_to_table/prefix"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/filtered_variants_to_table/variants_tsv",
                            "id": "#germline_detect_variants.cwl/filtered_add_vep_fields_to_table/tsv"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/filter_vcf/filtered_vcf",
                            "id": "#germline_detect_variants.cwl/filtered_add_vep_fields_to_table/vcf"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/vep_to_table_fields",
                            "id": "#germline_detect_variants.cwl/filtered_add_vep_fields_to_table/vep_fields"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/filtered_add_vep_fields_to_table/annotated_variants_tsv"
                    ],
                    "id": "#germline_detect_variants.cwl/filtered_add_vep_fields_to_table"
                },
                {
                    "run": "#variants_to_table.cwl",
                    "in": [
                        {
                            "source": "#germline_detect_variants.cwl/variants_to_table_fields",
                            "id": "#germline_detect_variants.cwl/filtered_variants_to_table/fields"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/variants_to_table_genotype_fields",
                            "id": "#germline_detect_variants.cwl/filtered_variants_to_table/genotype_fields"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/reference",
                            "id": "#germline_detect_variants.cwl/filtered_variants_to_table/reference"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/filter_vcf/filtered_vcf",
                            "id": "#germline_detect_variants.cwl/filtered_variants_to_table/vcf"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/filtered_variants_to_table/variants_tsv"
                    ],
                    "id": "#germline_detect_variants.cwl/filtered_variants_to_table"
                },
                {
                    "run": "#add_vep_fields_to_table.cwl",
                    "in": [
                        {
                            "source": "#germline_detect_variants.cwl/final_tsv_prefix",
                            "id": "#germline_detect_variants.cwl/final_add_vep_fields_to_table/prefix"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/final_variants_to_table/variants_tsv",
                            "id": "#germline_detect_variants.cwl/final_add_vep_fields_to_table/tsv"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/filter_vcf/final_vcf",
                            "id": "#germline_detect_variants.cwl/final_add_vep_fields_to_table/vcf"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/vep_to_table_fields",
                            "id": "#germline_detect_variants.cwl/final_add_vep_fields_to_table/vep_fields"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/final_add_vep_fields_to_table/annotated_variants_tsv"
                    ],
                    "id": "#germline_detect_variants.cwl/final_add_vep_fields_to_table"
                },
                {
                    "run": "#variants_to_table.cwl",
                    "in": [
                        {
                            "source": "#germline_detect_variants.cwl/variants_to_table_fields",
                            "id": "#germline_detect_variants.cwl/final_variants_to_table/fields"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/variants_to_table_genotype_fields",
                            "id": "#germline_detect_variants.cwl/final_variants_to_table/genotype_fields"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/reference",
                            "id": "#germline_detect_variants.cwl/final_variants_to_table/reference"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/filter_vcf/final_vcf",
                            "id": "#germline_detect_variants.cwl/final_variants_to_table/vcf"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/final_variants_to_table/variants_tsv"
                    ],
                    "id": "#germline_detect_variants.cwl/final_variants_to_table"
                },
                {
                    "run": "#gatk_genotypegvcfs.cwl",
                    "in": [
                        {
                            "source": "#germline_detect_variants.cwl/haplotype_caller/gvcf",
                            "id": "#germline_detect_variants.cwl/genotype_gvcfs/gvcfs"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/reference",
                            "id": "#germline_detect_variants.cwl/genotype_gvcfs/reference"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/genotype_gvcfs/genotype_vcf"
                    ],
                    "id": "#germline_detect_variants.cwl/genotype_gvcfs"
                },
                {
                    "run": "#gatk_haplotypecaller_iterator.cwl",
                    "in": [
                        {
                            "source": "#germline_detect_variants.cwl/bam",
                            "id": "#germline_detect_variants.cwl/haplotype_caller/bam"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/contamination_fraction",
                            "id": "#germline_detect_variants.cwl/haplotype_caller/contamination_fraction"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/emit_reference_confidence",
                            "id": "#germline_detect_variants.cwl/haplotype_caller/emit_reference_confidence"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/gvcf_gq_bands",
                            "id": "#germline_detect_variants.cwl/haplotype_caller/gvcf_gq_bands"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/intervals",
                            "id": "#germline_detect_variants.cwl/haplotype_caller/intervals"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/reference",
                            "id": "#germline_detect_variants.cwl/haplotype_caller/reference"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/haplotype_caller/gvcf"
                    ],
                    "id": "#germline_detect_variants.cwl/haplotype_caller"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#germline_detect_variants.cwl/bgzip_annotated_vcf/bgzipped_file",
                            "id": "#germline_detect_variants.cwl/index_annotated_vcf/vcf"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/index_annotated_vcf/indexed_vcf"
                    ],
                    "id": "#germline_detect_variants.cwl/index_annotated_vcf"
                },
                {
                    "run": "#staged_rename.cwl",
                    "in": [
                        {
                            "valueFrom": "annotated.filtered.tsv",
                            "id": "#germline_detect_variants.cwl/set_filtered_tsv_name/name"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/filtered_add_vep_fields_to_table/annotated_variants_tsv",
                            "id": "#germline_detect_variants.cwl/set_filtered_tsv_name/original"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/set_filtered_tsv_name/replacement"
                    ],
                    "id": "#germline_detect_variants.cwl/set_filtered_tsv_name"
                },
                {
                    "run": "#staged_rename.cwl",
                    "in": [
                        {
                            "valueFrom": "annotated.filtered.final.tsv",
                            "id": "#germline_detect_variants.cwl/set_final_tsv_name/name"
                        },
                        {
                            "source": "#germline_detect_variants.cwl/final_add_vep_fields_to_table/annotated_variants_tsv",
                            "id": "#germline_detect_variants.cwl/set_final_tsv_name/original"
                        }
                    ],
                    "out": [
                        "#germline_detect_variants.cwl/set_final_tsv_name/replacement"
                    ],
                    "id": "#germline_detect_variants.cwl/set_final_tsv_name"
                }
            ],
            "id": "#germline_detect_variants.cwl"
        },
        {
            "class": "Workflow",
            "label": "Apply filters to VCF file",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#germline_filter_vcf.cwl/annotated_vcf"
                },
                {
                    "type": "float",
                    "id": "#germline_filter_vcf.cwl/filter_gnomAD_maximum_population_allele_frequency"
                },
                {
                    "type": "string",
                    "id": "#germline_filter_vcf.cwl/gnomad_field_name"
                },
                {
                    "type": "File",
                    "id": "#germline_filter_vcf.cwl/limit_variant_intervals"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#germline_filter_vcf.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "outputSource": "#germline_filter_vcf.cwl/index_filtered_vcf/indexed_vcf",
                    "id": "#germline_filter_vcf.cwl/filtered_vcf"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "outputSource": "#germline_filter_vcf.cwl/limit_variants/filtered_vcf",
                    "id": "#germline_filter_vcf.cwl/final_vcf"
                }
            ],
            "steps": [
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#germline_filter_vcf.cwl/set_filtered_vcf_name/replacement",
                            "id": "#germline_filter_vcf.cwl/bgzip_filtered_vcf/file"
                        }
                    ],
                    "out": [
                        "#germline_filter_vcf.cwl/bgzip_filtered_vcf/bgzipped_file"
                    ],
                    "id": "#germline_filter_vcf.cwl/bgzip_filtered_vcf"
                },
                {
                    "run": "#filter_vcf_coding_variant.cwl",
                    "in": [
                        {
                            "source": "#germline_filter_vcf.cwl/annotated_vcf",
                            "id": "#germline_filter_vcf.cwl/coding_variant_filter/vcf"
                        }
                    ],
                    "out": [
                        "#germline_filter_vcf.cwl/coding_variant_filter/filtered_vcf"
                    ],
                    "id": "#germline_filter_vcf.cwl/coding_variant_filter"
                },
                {
                    "run": "#filter_vcf_custom_allele_freq.cwl",
                    "in": [
                        {
                            "source": "#germline_filter_vcf.cwl/gnomad_field_name",
                            "id": "#germline_filter_vcf.cwl/gnomad_frequency_filter/field_name"
                        },
                        {
                            "source": "#germline_filter_vcf.cwl/filter_gnomAD_maximum_population_allele_frequency",
                            "id": "#germline_filter_vcf.cwl/gnomad_frequency_filter/maximum_population_allele_frequency"
                        },
                        {
                            "source": "#germline_filter_vcf.cwl/coding_variant_filter/filtered_vcf",
                            "id": "#germline_filter_vcf.cwl/gnomad_frequency_filter/vcf"
                        }
                    ],
                    "out": [
                        "#germline_filter_vcf.cwl/gnomad_frequency_filter/filtered_vcf"
                    ],
                    "id": "#germline_filter_vcf.cwl/gnomad_frequency_filter"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#germline_filter_vcf.cwl/bgzip_filtered_vcf/bgzipped_file",
                            "id": "#germline_filter_vcf.cwl/index_filtered_vcf/vcf"
                        }
                    ],
                    "out": [
                        "#germline_filter_vcf.cwl/index_filtered_vcf/indexed_vcf"
                    ],
                    "id": "#germline_filter_vcf.cwl/index_filtered_vcf"
                },
                {
                    "run": "#select_variants.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#germline_filter_vcf.cwl/limit_variants/exclude_filtered"
                        },
                        {
                            "source": "#germline_filter_vcf.cwl/limit_variant_intervals",
                            "id": "#germline_filter_vcf.cwl/limit_variants/interval_list"
                        },
                        {
                            "default": "annotated.filtered.final",
                            "id": "#germline_filter_vcf.cwl/limit_variants/output_vcf_basename"
                        },
                        {
                            "source": "#germline_filter_vcf.cwl/reference",
                            "id": "#germline_filter_vcf.cwl/limit_variants/reference"
                        },
                        {
                            "source": "#germline_filter_vcf.cwl/index_filtered_vcf/indexed_vcf",
                            "id": "#germline_filter_vcf.cwl/limit_variants/vcf"
                        }
                    ],
                    "out": [
                        "#germline_filter_vcf.cwl/limit_variants/filtered_vcf"
                    ],
                    "id": "#germline_filter_vcf.cwl/limit_variants"
                },
                {
                    "run": "#staged_rename.cwl",
                    "in": [
                        {
                            "valueFrom": "annotated.filtered.vcf",
                            "id": "#germline_filter_vcf.cwl/set_filtered_vcf_name/name"
                        },
                        {
                            "source": "#germline_filter_vcf.cwl/gnomad_frequency_filter/filtered_vcf",
                            "id": "#germline_filter_vcf.cwl/set_filtered_vcf_name/original"
                        }
                    ],
                    "out": [
                        "#germline_filter_vcf.cwl/set_filtered_vcf_name/replacement"
                    ],
                    "id": "#germline_filter_vcf.cwl/set_filtered_vcf_name"
                }
            ],
            "id": "#germline_filter_vcf.cwl"
        },
        {
            "class": "Workflow",
            "label": "HS Metrics workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#labelled_file.yml/labelled_file"
                        }
                    ]
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#hs_metrics.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#hs_metrics.cwl/minimum_base_quality"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#hs_metrics.cwl/minimum_mapping_quality"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#hs_metrics.cwl/per_base_intervals"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#hs_metrics.cwl/per_target_intervals"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#hs_metrics.cwl/reference"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#hs_metrics.cwl/summary_intervals"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#hs_metrics.cwl/collect_per_base_hs_metrics/per_base_coverage_metrics",
                    "id": "#hs_metrics.cwl/per_base_coverage_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#hs_metrics.cwl/collect_per_base_hs_metrics/hs_metrics",
                    "id": "#hs_metrics.cwl/per_base_hs_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#hs_metrics.cwl/collect_per_target_hs_metrics/per_target_coverage_metrics",
                    "id": "#hs_metrics.cwl/per_target_coverage_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#hs_metrics.cwl/collect_per_target_hs_metrics/hs_metrics",
                    "id": "#hs_metrics.cwl/per_target_hs_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#hs_metrics.cwl/collect_summary_hs_metrics/hs_metrics",
                    "id": "#hs_metrics.cwl/summary_hs_metrics"
                }
            ],
            "steps": [
                {
                    "run": "#collect_hs_metrics.cwl",
                    "scatter": [
                        "#hs_metrics.cwl/collect_per_base_hs_metrics/bait_intervals",
                        "#hs_metrics.cwl/collect_per_base_hs_metrics/target_intervals",
                        "#hs_metrics.cwl/collect_per_base_hs_metrics/output_prefix"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#hs_metrics.cwl/per_base_intervals",
                            "valueFrom": "$(self.file)",
                            "id": "#hs_metrics.cwl/collect_per_base_hs_metrics/bait_intervals"
                        },
                        {
                            "source": "#hs_metrics.cwl/bam",
                            "id": "#hs_metrics.cwl/collect_per_base_hs_metrics/bam"
                        },
                        {
                            "valueFrom": "ALL_READS",
                            "id": "#hs_metrics.cwl/collect_per_base_hs_metrics/metric_accumulation_level"
                        },
                        {
                            "source": "#hs_metrics.cwl/minimum_base_quality",
                            "id": "#hs_metrics.cwl/collect_per_base_hs_metrics/minimum_base_quality"
                        },
                        {
                            "source": "#hs_metrics.cwl/minimum_mapping_quality",
                            "id": "#hs_metrics.cwl/collect_per_base_hs_metrics/minimum_mapping_quality"
                        },
                        {
                            "source": "#hs_metrics.cwl/per_base_intervals",
                            "valueFrom": "base-$(self.label)",
                            "id": "#hs_metrics.cwl/collect_per_base_hs_metrics/output_prefix"
                        },
                        {
                            "default": true,
                            "id": "#hs_metrics.cwl/collect_per_base_hs_metrics/per_base_coverage"
                        },
                        {
                            "default": false,
                            "id": "#hs_metrics.cwl/collect_per_base_hs_metrics/per_target_coverage"
                        },
                        {
                            "source": "#hs_metrics.cwl/reference",
                            "id": "#hs_metrics.cwl/collect_per_base_hs_metrics/reference"
                        },
                        {
                            "source": "#hs_metrics.cwl/per_base_intervals",
                            "valueFrom": "$(self.file)",
                            "id": "#hs_metrics.cwl/collect_per_base_hs_metrics/target_intervals"
                        }
                    ],
                    "out": [
                        "#hs_metrics.cwl/collect_per_base_hs_metrics/hs_metrics",
                        "#hs_metrics.cwl/collect_per_base_hs_metrics/per_base_coverage_metrics"
                    ],
                    "id": "#hs_metrics.cwl/collect_per_base_hs_metrics"
                },
                {
                    "run": "#collect_hs_metrics.cwl",
                    "scatter": [
                        "#hs_metrics.cwl/collect_per_target_hs_metrics/bait_intervals",
                        "#hs_metrics.cwl/collect_per_target_hs_metrics/target_intervals",
                        "#hs_metrics.cwl/collect_per_target_hs_metrics/output_prefix"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#hs_metrics.cwl/per_target_intervals",
                            "valueFrom": "$(self.file)",
                            "id": "#hs_metrics.cwl/collect_per_target_hs_metrics/bait_intervals"
                        },
                        {
                            "source": "#hs_metrics.cwl/bam",
                            "id": "#hs_metrics.cwl/collect_per_target_hs_metrics/bam"
                        },
                        {
                            "valueFrom": "ALL_READS",
                            "id": "#hs_metrics.cwl/collect_per_target_hs_metrics/metric_accumulation_level"
                        },
                        {
                            "source": "#hs_metrics.cwl/minimum_base_quality",
                            "id": "#hs_metrics.cwl/collect_per_target_hs_metrics/minimum_base_quality"
                        },
                        {
                            "source": "#hs_metrics.cwl/minimum_mapping_quality",
                            "id": "#hs_metrics.cwl/collect_per_target_hs_metrics/minimum_mapping_quality"
                        },
                        {
                            "source": "#hs_metrics.cwl/per_target_intervals",
                            "valueFrom": "target-$(self.label)",
                            "id": "#hs_metrics.cwl/collect_per_target_hs_metrics/output_prefix"
                        },
                        {
                            "default": false,
                            "id": "#hs_metrics.cwl/collect_per_target_hs_metrics/per_base_coverage"
                        },
                        {
                            "default": true,
                            "id": "#hs_metrics.cwl/collect_per_target_hs_metrics/per_target_coverage"
                        },
                        {
                            "source": "#hs_metrics.cwl/reference",
                            "id": "#hs_metrics.cwl/collect_per_target_hs_metrics/reference"
                        },
                        {
                            "source": "#hs_metrics.cwl/per_target_intervals",
                            "valueFrom": "$(self.file)",
                            "id": "#hs_metrics.cwl/collect_per_target_hs_metrics/target_intervals"
                        }
                    ],
                    "out": [
                        "#hs_metrics.cwl/collect_per_target_hs_metrics/hs_metrics",
                        "#hs_metrics.cwl/collect_per_target_hs_metrics/per_target_coverage_metrics"
                    ],
                    "id": "#hs_metrics.cwl/collect_per_target_hs_metrics"
                },
                {
                    "run": "#collect_hs_metrics.cwl",
                    "scatter": [
                        "#hs_metrics.cwl/collect_summary_hs_metrics/bait_intervals",
                        "#hs_metrics.cwl/collect_summary_hs_metrics/target_intervals",
                        "#hs_metrics.cwl/collect_summary_hs_metrics/output_prefix"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#hs_metrics.cwl/summary_intervals",
                            "valueFrom": "$(self.file)",
                            "id": "#hs_metrics.cwl/collect_summary_hs_metrics/bait_intervals"
                        },
                        {
                            "source": "#hs_metrics.cwl/bam",
                            "id": "#hs_metrics.cwl/collect_summary_hs_metrics/bam"
                        },
                        {
                            "valueFrom": "ALL_READS",
                            "id": "#hs_metrics.cwl/collect_summary_hs_metrics/metric_accumulation_level"
                        },
                        {
                            "source": "#hs_metrics.cwl/minimum_base_quality",
                            "id": "#hs_metrics.cwl/collect_summary_hs_metrics/minimum_base_quality"
                        },
                        {
                            "source": "#hs_metrics.cwl/minimum_mapping_quality",
                            "id": "#hs_metrics.cwl/collect_summary_hs_metrics/minimum_mapping_quality"
                        },
                        {
                            "source": "#hs_metrics.cwl/summary_intervals",
                            "valueFrom": "summary-$(self.label)",
                            "id": "#hs_metrics.cwl/collect_summary_hs_metrics/output_prefix"
                        },
                        {
                            "default": false,
                            "id": "#hs_metrics.cwl/collect_summary_hs_metrics/per_base_coverage"
                        },
                        {
                            "default": false,
                            "id": "#hs_metrics.cwl/collect_summary_hs_metrics/per_target_coverage"
                        },
                        {
                            "source": "#hs_metrics.cwl/reference",
                            "id": "#hs_metrics.cwl/collect_summary_hs_metrics/reference"
                        },
                        {
                            "source": "#hs_metrics.cwl/summary_intervals",
                            "valueFrom": "$(self.file)",
                            "id": "#hs_metrics.cwl/collect_summary_hs_metrics/target_intervals"
                        }
                    ],
                    "out": [
                        "#hs_metrics.cwl/collect_summary_hs_metrics/hs_metrics"
                    ],
                    "id": "#hs_metrics.cwl/collect_summary_hs_metrics"
                }
            ],
            "id": "#hs_metrics.cwl"
        },
        {
            "class": "Workflow",
            "label": "Merge, annotate, and generate a TSV for SVs",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#merge_svs.cwl/cohort_name"
                },
                {
                    "type": "boolean",
                    "id": "#merge_svs.cwl/estimate_sv_distance"
                },
                {
                    "type": "string",
                    "id": "#merge_svs.cwl/genome_build"
                },
                {
                    "type": "int",
                    "id": "#merge_svs.cwl/max_distance_to_merge"
                },
                {
                    "type": "int",
                    "id": "#merge_svs.cwl/minimum_sv_calls"
                },
                {
                    "type": "int",
                    "id": "#merge_svs.cwl/minimum_sv_size"
                },
                {
                    "type": "boolean",
                    "id": "#merge_svs.cwl/same_strand"
                },
                {
                    "type": "boolean",
                    "id": "#merge_svs.cwl/same_type"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#merge_svs.cwl/snps_vcf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#merge_svs.cwl/sv_vcfs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#merge_svs.cwl/bcftools_annotate_variants/sv_variants_tsv",
                    "id": "#merge_svs.cwl/bcftools_merged_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#merge_svs.cwl/bcftools_annotsv_filter/filtered_tsv",
                    "id": "#merge_svs.cwl/bcftools_merged_filtered_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#merge_svs.cwl/bcftools_bgzip_merged_sv_vcf/bgzipped_file",
                    "id": "#merge_svs.cwl/bcftools_merged_sv_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#merge_svs.cwl/survivor_annotate_variants/sv_variants_tsv",
                    "id": "#merge_svs.cwl/survivor_merged_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#merge_svs.cwl/survivor_bgzip_merged_sv_vcf/bgzipped_file",
                    "id": "#merge_svs.cwl/survivor_merged_sv_vcf"
                }
            ],
            "steps": [
                {
                    "run": "#annotsv.cwl",
                    "in": [
                        {
                            "source": "#merge_svs.cwl/genome_build",
                            "id": "#merge_svs.cwl/bcftools_annotate_variants/genome_build"
                        },
                        {
                            "source": "#merge_svs.cwl/bcftools_merge_sv_vcfs/merged_sv_vcf",
                            "id": "#merge_svs.cwl/bcftools_annotate_variants/input_vcf"
                        },
                        {
                            "default": "bcftools-merged-AnnotSV.tsv",
                            "id": "#merge_svs.cwl/bcftools_annotate_variants/output_tsv_name"
                        },
                        {
                            "source": [
                                "#merge_svs.cwl/snps_vcf"
                            ],
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#merge_svs.cwl/bcftools_annotate_variants/snps_vcf"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/bcftools_annotate_variants/sv_variants_tsv"
                    ],
                    "id": "#merge_svs.cwl/bcftools_annotate_variants"
                },
                {
                    "run": "#annotsv_filter.cwl",
                    "in": [
                        {
                            "source": "#merge_svs.cwl/bcftools_annotate_variants/sv_variants_tsv",
                            "id": "#merge_svs.cwl/bcftools_annotsv_filter/annotsv_tsv"
                        },
                        {
                            "default": "0.05",
                            "id": "#merge_svs.cwl/bcftools_annotsv_filter/filtering_frequency"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/bcftools_annotsv_filter/filtered_tsv"
                    ],
                    "id": "#merge_svs.cwl/bcftools_annotsv_filter"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#merge_svs.cwl/bcftools_merge_sv_vcfs/merged_sv_vcf",
                            "id": "#merge_svs.cwl/bcftools_bgzip_merged_sv_vcf/file"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/bcftools_bgzip_merged_sv_vcf/bgzipped_file"
                    ],
                    "id": "#merge_svs.cwl/bcftools_bgzip_merged_sv_vcf"
                },
                {
                    "run": "#bcftools_merge.cwl",
                    "in": [
                        {
                            "default": "none",
                            "id": "#merge_svs.cwl/bcftools_merge_sv_vcfs/merge_method"
                        },
                        {
                            "default": "v",
                            "id": "#merge_svs.cwl/bcftools_merge_sv_vcfs/output_type"
                        },
                        {
                            "default": "bcftools-sv-merged.vcf",
                            "id": "#merge_svs.cwl/bcftools_merge_sv_vcfs/output_vcf_name"
                        },
                        {
                            "source": "#merge_svs.cwl/sv_vcfs",
                            "id": "#merge_svs.cwl/bcftools_merge_sv_vcfs/vcfs"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/bcftools_merge_sv_vcfs/merged_sv_vcf"
                    ],
                    "id": "#merge_svs.cwl/bcftools_merge_sv_vcfs"
                },
                {
                    "run": "#annotsv.cwl",
                    "in": [
                        {
                            "source": "#merge_svs.cwl/genome_build",
                            "id": "#merge_svs.cwl/survivor_annotate_variants/genome_build"
                        },
                        {
                            "source": "#merge_svs.cwl/survivor_merge_sv_vcfs/merged_vcf",
                            "id": "#merge_svs.cwl/survivor_annotate_variants/input_vcf"
                        },
                        {
                            "default": "SURVIVOR-merged-AnnotSV.tsv",
                            "id": "#merge_svs.cwl/survivor_annotate_variants/output_tsv_name"
                        },
                        {
                            "source": [
                                "#merge_svs.cwl/snps_vcf"
                            ],
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#merge_svs.cwl/survivor_annotate_variants/snps_vcf"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/survivor_annotate_variants/sv_variants_tsv"
                    ],
                    "id": "#merge_svs.cwl/survivor_annotate_variants"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#merge_svs.cwl/survivor_merge_sv_vcfs/merged_vcf",
                            "id": "#merge_svs.cwl/survivor_bgzip_merged_sv_vcf/file"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/survivor_bgzip_merged_sv_vcf/bgzipped_file"
                    ],
                    "id": "#merge_svs.cwl/survivor_bgzip_merged_sv_vcf"
                },
                {
                    "run": "#survivor.cwl",
                    "in": [
                        {
                            "default": "SURVIVOR-sv-merged.vcf",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/cohort_name"
                        },
                        {
                            "source": "#merge_svs.cwl/estimate_sv_distance",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/estimate_sv_distance"
                        },
                        {
                            "source": "#merge_svs.cwl/max_distance_to_merge",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/max_distance_to_merge"
                        },
                        {
                            "source": "#merge_svs.cwl/minimum_sv_calls",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/minimum_sv_calls"
                        },
                        {
                            "source": "#merge_svs.cwl/minimum_sv_size",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/minimum_sv_size"
                        },
                        {
                            "source": "#merge_svs.cwl/same_strand",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/same_strand"
                        },
                        {
                            "source": "#merge_svs.cwl/same_type",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/same_type"
                        },
                        {
                            "source": "#merge_svs.cwl/sv_vcfs",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/vcfs"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/survivor_merge_sv_vcfs/merged_vcf"
                    ],
                    "id": "#merge_svs.cwl/survivor_merge_sv_vcfs"
                }
            ],
            "id": "#merge_svs.cwl"
        },
        {
            "class": "Workflow",
            "label": "WGS QC workflow",
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#labelled_file.yml/labelled_file"
                        }
                    ]
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#qc_wgs.cwl/bam"
                },
                {
                    "type": "File",
                    "id": "#qc_wgs.cwl/intervals"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#qc_wgs.cwl/minimum_base_quality"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#qc_wgs.cwl/minimum_mapping_quality"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#qc_wgs.cwl/omni_vcf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#qc_wgs.cwl/per_base_intervals"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#qc_wgs.cwl/per_target_intervals"
                },
                {
                    "type": "string",
                    "default": "ALL_READS",
                    "id": "#qc_wgs.cwl/picard_metric_accumulation_level"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#qc_wgs.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "final",
                    "id": "#qc_wgs.cwl/sample_name"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#labelled_file.yml/labelled_file"
                    },
                    "id": "#qc_wgs.cwl/summary_intervals"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#qc_wgs.cwl/collect_alignment_summary_metrics/alignment_summary_metrics",
                    "id": "#qc_wgs.cwl/alignment_summary_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#qc_wgs.cwl/samtools_flagstat/flagstats",
                    "id": "#qc_wgs.cwl/flagstats"
                },
                {
                    "type": "File",
                    "outputSource": "#qc_wgs.cwl/collect_gc_bias_metrics/gc_bias_metrics",
                    "id": "#qc_wgs.cwl/gc_bias_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#qc_wgs.cwl/collect_gc_bias_metrics/gc_bias_metrics_chart",
                    "id": "#qc_wgs.cwl/gc_bias_metrics_chart"
                },
                {
                    "type": "File",
                    "outputSource": "#qc_wgs.cwl/collect_gc_bias_metrics/gc_bias_metrics_summary",
                    "id": "#qc_wgs.cwl/gc_bias_metrics_summary"
                },
                {
                    "type": "File",
                    "outputSource": "#qc_wgs.cwl/collect_insert_size_metrics/insert_size_histogram",
                    "id": "#qc_wgs.cwl/insert_size_histogram"
                },
                {
                    "type": "File",
                    "outputSource": "#qc_wgs.cwl/collect_insert_size_metrics/insert_size_metrics",
                    "id": "#qc_wgs.cwl/insert_size_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#qc_wgs.cwl/collect_hs_metrics/per_base_coverage_metrics",
                    "id": "#qc_wgs.cwl/per_base_coverage_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#qc_wgs.cwl/collect_hs_metrics/per_base_hs_metrics",
                    "id": "#qc_wgs.cwl/per_base_hs_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#qc_wgs.cwl/collect_hs_metrics/per_target_coverage_metrics",
                    "id": "#qc_wgs.cwl/per_target_coverage_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#qc_wgs.cwl/collect_hs_metrics/per_target_hs_metrics",
                    "id": "#qc_wgs.cwl/per_target_hs_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#qc_wgs.cwl/collect_hs_metrics/summary_hs_metrics",
                    "id": "#qc_wgs.cwl/summary_hs_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#qc_wgs.cwl/verify_bam_id/verify_bam_id_depth",
                    "id": "#qc_wgs.cwl/verify_bam_id_depth"
                },
                {
                    "type": "File",
                    "outputSource": "#qc_wgs.cwl/verify_bam_id/verify_bam_id_metrics",
                    "id": "#qc_wgs.cwl/verify_bam_id_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#qc_wgs.cwl/collect_wgs_metrics/wgs_metrics",
                    "id": "#qc_wgs.cwl/wgs_metrics"
                }
            ],
            "steps": [
                {
                    "run": "#collect_alignment_summary_metrics.cwl",
                    "in": [
                        {
                            "source": "#qc_wgs.cwl/bam",
                            "id": "#qc_wgs.cwl/collect_alignment_summary_metrics/bam"
                        },
                        {
                            "source": "#qc_wgs.cwl/picard_metric_accumulation_level",
                            "id": "#qc_wgs.cwl/collect_alignment_summary_metrics/metric_accumulation_level"
                        },
                        {
                            "source": "#qc_wgs.cwl/reference",
                            "id": "#qc_wgs.cwl/collect_alignment_summary_metrics/reference"
                        }
                    ],
                    "out": [
                        "#qc_wgs.cwl/collect_alignment_summary_metrics/alignment_summary_metrics"
                    ],
                    "id": "#qc_wgs.cwl/collect_alignment_summary_metrics"
                },
                {
                    "run": "#collect_gc_bias_metrics.cwl",
                    "in": [
                        {
                            "source": "#qc_wgs.cwl/bam",
                            "id": "#qc_wgs.cwl/collect_gc_bias_metrics/bam"
                        },
                        {
                            "source": "#qc_wgs.cwl/picard_metric_accumulation_level",
                            "id": "#qc_wgs.cwl/collect_gc_bias_metrics/metric_accumulation_level"
                        },
                        {
                            "source": "#qc_wgs.cwl/reference",
                            "id": "#qc_wgs.cwl/collect_gc_bias_metrics/reference"
                        },
                        {
                            "source": "#qc_wgs.cwl/sample_name",
                            "id": "#qc_wgs.cwl/collect_gc_bias_metrics/sample_name"
                        }
                    ],
                    "out": [
                        "#qc_wgs.cwl/collect_gc_bias_metrics/gc_bias_metrics",
                        "#qc_wgs.cwl/collect_gc_bias_metrics/gc_bias_metrics_chart",
                        "#qc_wgs.cwl/collect_gc_bias_metrics/gc_bias_metrics_summary"
                    ],
                    "id": "#qc_wgs.cwl/collect_gc_bias_metrics"
                },
                {
                    "run": "#hs_metrics.cwl",
                    "in": [
                        {
                            "source": "#qc_wgs.cwl/bam",
                            "id": "#qc_wgs.cwl/collect_hs_metrics/bam"
                        },
                        {
                            "source": "#qc_wgs.cwl/minimum_base_quality",
                            "id": "#qc_wgs.cwl/collect_hs_metrics/minimum_base_quality"
                        },
                        {
                            "source": "#qc_wgs.cwl/minimum_mapping_quality",
                            "id": "#qc_wgs.cwl/collect_hs_metrics/minimum_mapping_quality"
                        },
                        {
                            "source": "#qc_wgs.cwl/per_base_intervals",
                            "id": "#qc_wgs.cwl/collect_hs_metrics/per_base_intervals"
                        },
                        {
                            "source": "#qc_wgs.cwl/per_target_intervals",
                            "id": "#qc_wgs.cwl/collect_hs_metrics/per_target_intervals"
                        },
                        {
                            "source": "#qc_wgs.cwl/reference",
                            "id": "#qc_wgs.cwl/collect_hs_metrics/reference"
                        },
                        {
                            "source": "#qc_wgs.cwl/summary_intervals",
                            "id": "#qc_wgs.cwl/collect_hs_metrics/summary_intervals"
                        }
                    ],
                    "out": [
                        "#qc_wgs.cwl/collect_hs_metrics/per_base_coverage_metrics",
                        "#qc_wgs.cwl/collect_hs_metrics/per_base_hs_metrics",
                        "#qc_wgs.cwl/collect_hs_metrics/per_target_coverage_metrics",
                        "#qc_wgs.cwl/collect_hs_metrics/per_target_hs_metrics",
                        "#qc_wgs.cwl/collect_hs_metrics/summary_hs_metrics"
                    ],
                    "id": "#qc_wgs.cwl/collect_hs_metrics"
                },
                {
                    "run": "#collect_insert_size_metrics.cwl",
                    "in": [
                        {
                            "source": "#qc_wgs.cwl/bam",
                            "id": "#qc_wgs.cwl/collect_insert_size_metrics/bam"
                        },
                        {
                            "source": "#qc_wgs.cwl/picard_metric_accumulation_level",
                            "id": "#qc_wgs.cwl/collect_insert_size_metrics/metric_accumulation_level"
                        },
                        {
                            "source": "#qc_wgs.cwl/reference",
                            "id": "#qc_wgs.cwl/collect_insert_size_metrics/reference"
                        }
                    ],
                    "out": [
                        "#qc_wgs.cwl/collect_insert_size_metrics/insert_size_metrics",
                        "#qc_wgs.cwl/collect_insert_size_metrics/insert_size_histogram"
                    ],
                    "id": "#qc_wgs.cwl/collect_insert_size_metrics"
                },
                {
                    "run": "#collect_wgs_metrics.cwl",
                    "in": [
                        {
                            "source": "#qc_wgs.cwl/bam",
                            "id": "#qc_wgs.cwl/collect_wgs_metrics/bam"
                        },
                        {
                            "source": "#qc_wgs.cwl/intervals",
                            "id": "#qc_wgs.cwl/collect_wgs_metrics/intervals"
                        },
                        {
                            "source": "#qc_wgs.cwl/reference",
                            "id": "#qc_wgs.cwl/collect_wgs_metrics/reference"
                        },
                        {
                            "source": "#qc_wgs.cwl/sample_name",
                            "id": "#qc_wgs.cwl/collect_wgs_metrics/sample_name"
                        }
                    ],
                    "out": [
                        "#qc_wgs.cwl/collect_wgs_metrics/wgs_metrics"
                    ],
                    "id": "#qc_wgs.cwl/collect_wgs_metrics"
                },
                {
                    "run": "#samtools_flagstat.cwl",
                    "in": [
                        {
                            "source": "#qc_wgs.cwl/bam",
                            "id": "#qc_wgs.cwl/samtools_flagstat/bam"
                        }
                    ],
                    "out": [
                        "#qc_wgs.cwl/samtools_flagstat/flagstats"
                    ],
                    "id": "#qc_wgs.cwl/samtools_flagstat"
                },
                {
                    "run": "#verify_bam_id.cwl",
                    "in": [
                        {
                            "source": "#qc_wgs.cwl/bam",
                            "id": "#qc_wgs.cwl/verify_bam_id/bam"
                        },
                        {
                            "source": "#qc_wgs.cwl/omni_vcf",
                            "id": "#qc_wgs.cwl/verify_bam_id/vcf"
                        }
                    ],
                    "out": [
                        "#qc_wgs.cwl/verify_bam_id/verify_bam_id_metrics",
                        "#qc_wgs.cwl/verify_bam_id/verify_bam_id_depth"
                    ],
                    "id": "#qc_wgs.cwl/verify_bam_id"
                }
            ],
            "id": "#qc_wgs.cwl"
        },
        {
            "class": "Workflow",
            "label": "adapter for sequence_align_and_tag",
            "doc": "Some workflow engines won't stage files in our nested structure, so parse it out here",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#sequence_data.yml/sequence_data"
                        }
                    ]
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ],
                    "doc": "bwa-indexed reference file",
                    "id": "#sequence_align_and_tag_adapter.cwl/reference"
                },
                {
                    "type": "#sequence_data.yml/sequence_data",
                    "doc": "the unaligned sequence data with readgroup information",
                    "id": "#sequence_align_and_tag_adapter.cwl/unaligned"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#sequence_align_and_tag_adapter.cwl/align_and_tag/aligned_bam",
                    "id": "#sequence_align_and_tag_adapter.cwl/aligned_bam"
                }
            ],
            "steps": [
                {
                    "run": "#sequence_align_and_tag.cwl",
                    "in": [
                        {
                            "source": "#sequence_align_and_tag_adapter.cwl/unaligned",
                            "valueFrom": "$(self.sequence.hasOwnProperty('bam')? self.sequence.bam : null)",
                            "id": "#sequence_align_and_tag_adapter.cwl/align_and_tag/bam"
                        },
                        {
                            "source": "#sequence_align_and_tag_adapter.cwl/unaligned",
                            "valueFrom": "$(self.sequence.hasOwnProperty('fastq1')? self.sequence.fastq1 : null)",
                            "id": "#sequence_align_and_tag_adapter.cwl/align_and_tag/fastq1"
                        },
                        {
                            "source": "#sequence_align_and_tag_adapter.cwl/unaligned",
                            "valueFrom": "$(self.sequence.hasOwnProperty('fastq2')? self.sequence.fastq2 : null)",
                            "id": "#sequence_align_and_tag_adapter.cwl/align_and_tag/fastq2"
                        },
                        {
                            "source": "#sequence_align_and_tag_adapter.cwl/unaligned",
                            "valueFrom": "$(self.readgroup)",
                            "id": "#sequence_align_and_tag_adapter.cwl/align_and_tag/readgroup"
                        },
                        {
                            "source": "#sequence_align_and_tag_adapter.cwl/reference",
                            "id": "#sequence_align_and_tag_adapter.cwl/align_and_tag/reference"
                        }
                    ],
                    "out": [
                        "#sequence_align_and_tag_adapter.cwl/align_and_tag/aligned_bam"
                    ],
                    "id": "#sequence_align_and_tag_adapter.cwl/align_and_tag"
                }
            ],
            "id": "#sequence_align_and_tag_adapter.cwl"
        },
        {
            "class": "Workflow",
            "label": "Raw sequence data to BQSR",
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#sequence_data.yml/sequence_data"
                        }
                    ]
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "id": "#sequence_to_bqsr.cwl/bqsr_intervals"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#sequence_to_bqsr.cwl/dbsnp_vcf"
                },
                {
                    "type": "string",
                    "default": "final",
                    "id": "#sequence_to_bqsr.cwl/final_name"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#sequence_to_bqsr.cwl/known_indels"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#sequence_to_bqsr.cwl/mills"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict",
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ],
                    "id": "#sequence_to_bqsr.cwl/reference"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#sequence_data.yml/sequence_data"
                    },
                    "id": "#sequence_to_bqsr.cwl/unaligned"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#sequence_to_bqsr.cwl/index_bam/indexed_bam",
                    "secondaryFiles": [
                        ".bai",
                        "^.bai"
                    ],
                    "id": "#sequence_to_bqsr.cwl/final_bam"
                },
                {
                    "type": "File",
                    "outputSource": "#sequence_to_bqsr.cwl/mark_duplicates_and_sort/metrics_file",
                    "id": "#sequence_to_bqsr.cwl/mark_duplicates_metrics_file"
                }
            ],
            "steps": [
                {
                    "scatter": [
                        "#sequence_to_bqsr.cwl/align/unaligned"
                    ],
                    "scatterMethod": "dotproduct",
                    "run": "#sequence_align_and_tag_adapter.cwl",
                    "in": [
                        {
                            "source": "#sequence_to_bqsr.cwl/reference",
                            "id": "#sequence_to_bqsr.cwl/align/reference"
                        },
                        {
                            "source": "#sequence_to_bqsr.cwl/unaligned",
                            "id": "#sequence_to_bqsr.cwl/align/unaligned"
                        }
                    ],
                    "out": [
                        "#sequence_to_bqsr.cwl/align/aligned_bam"
                    ],
                    "id": "#sequence_to_bqsr.cwl/align"
                },
                {
                    "run": "#apply_bqsr.cwl",
                    "in": [
                        {
                            "source": "#sequence_to_bqsr.cwl/mark_duplicates_and_sort/sorted_bam",
                            "id": "#sequence_to_bqsr.cwl/apply_bqsr/bam"
                        },
                        {
                            "source": "#sequence_to_bqsr.cwl/bqsr/bqsr_table",
                            "id": "#sequence_to_bqsr.cwl/apply_bqsr/bqsr_table"
                        },
                        {
                            "source": "#sequence_to_bqsr.cwl/final_name",
                            "id": "#sequence_to_bqsr.cwl/apply_bqsr/output_name"
                        },
                        {
                            "source": "#sequence_to_bqsr.cwl/reference",
                            "id": "#sequence_to_bqsr.cwl/apply_bqsr/reference"
                        }
                    ],
                    "out": [
                        "#sequence_to_bqsr.cwl/apply_bqsr/bqsr_bam"
                    ],
                    "id": "#sequence_to_bqsr.cwl/apply_bqsr"
                },
                {
                    "run": "#bqsr.cwl",
                    "in": [
                        {
                            "source": "#sequence_to_bqsr.cwl/mark_duplicates_and_sort/sorted_bam",
                            "id": "#sequence_to_bqsr.cwl/bqsr/bam"
                        },
                        {
                            "source": "#sequence_to_bqsr.cwl/bqsr_intervals",
                            "id": "#sequence_to_bqsr.cwl/bqsr/intervals"
                        },
                        {
                            "source": [
                                "#sequence_to_bqsr.cwl/dbsnp_vcf",
                                "#sequence_to_bqsr.cwl/mills",
                                "#sequence_to_bqsr.cwl/known_indels"
                            ],
                            "id": "#sequence_to_bqsr.cwl/bqsr/known_sites"
                        },
                        {
                            "source": "#sequence_to_bqsr.cwl/reference",
                            "id": "#sequence_to_bqsr.cwl/bqsr/reference"
                        }
                    ],
                    "out": [
                        "#sequence_to_bqsr.cwl/bqsr/bqsr_table"
                    ],
                    "id": "#sequence_to_bqsr.cwl/bqsr"
                },
                {
                    "run": "#index_bam.cwl",
                    "in": [
                        {
                            "source": "#sequence_to_bqsr.cwl/apply_bqsr/bqsr_bam",
                            "id": "#sequence_to_bqsr.cwl/index_bam/bam"
                        }
                    ],
                    "out": [
                        "#sequence_to_bqsr.cwl/index_bam/indexed_bam"
                    ],
                    "id": "#sequence_to_bqsr.cwl/index_bam"
                },
                {
                    "run": "#mark_duplicates_and_sort.cwl",
                    "in": [
                        {
                            "source": "#sequence_to_bqsr.cwl/name_sort/name_sorted_bam",
                            "id": "#sequence_to_bqsr.cwl/mark_duplicates_and_sort/bam"
                        }
                    ],
                    "out": [
                        "#sequence_to_bqsr.cwl/mark_duplicates_and_sort/sorted_bam",
                        "#sequence_to_bqsr.cwl/mark_duplicates_and_sort/metrics_file"
                    ],
                    "id": "#sequence_to_bqsr.cwl/mark_duplicates_and_sort"
                },
                {
                    "run": "#merge_bams_samtools.cwl",
                    "in": [
                        {
                            "source": "#sequence_to_bqsr.cwl/align/aligned_bam",
                            "id": "#sequence_to_bqsr.cwl/merge/bams"
                        },
                        {
                            "source": "#sequence_to_bqsr.cwl/final_name",
                            "id": "#sequence_to_bqsr.cwl/merge/name"
                        }
                    ],
                    "out": [
                        "#sequence_to_bqsr.cwl/merge/merged_bam"
                    ],
                    "id": "#sequence_to_bqsr.cwl/merge"
                },
                {
                    "run": "#name_sort.cwl",
                    "in": [
                        {
                            "source": "#sequence_to_bqsr.cwl/merge/merged_bam",
                            "id": "#sequence_to_bqsr.cwl/name_sort/bam"
                        }
                    ],
                    "out": [
                        "#sequence_to_bqsr.cwl/name_sort/name_sorted_bam"
                    ],
                    "id": "#sequence_to_bqsr.cwl/name_sort"
                }
            ],
            "id": "#sequence_to_bqsr.cwl"
        },
        {
            "class": "Workflow",
            "label": "Subworkflow to allow calling different SV callers which require bam files as inputs",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".bai",
                        "^.bai"
                    ],
                    "id": "#single_sample_sv_callers.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#single_sample_sv_callers.cwl/cnv_deletion_depth"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#single_sample_sv_callers.cwl/cnv_duplication_depth"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#single_sample_sv_callers.cwl/cnv_filter_min_size"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#single_sample_sv_callers.cwl/cnvkit_diagram"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#single_sample_sv_callers.cwl/cnvkit_drop_low_coverage"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#single_sample_sv_callers.cwl/cnvkit_male_reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#single_sample_sv_callers.cwl/cnvkit_method"
                },
                {
                    "type": "File",
                    "id": "#single_sample_sv_callers.cwl/cnvkit_reference_cnn"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#single_sample_sv_callers.cwl/cnvkit_scatter_plot"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#single_sample_sv_callers.cwl/cnvkit_vcf_name"
                },
                {
                    "type": "string",
                    "id": "#single_sample_sv_callers.cwl/genome_build"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#single_sample_sv_callers.cwl/manta_call_regions"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#single_sample_sv_callers.cwl/manta_non_wgs"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#single_sample_sv_callers.cwl/manta_output_contigs"
                },
                {
                    "type": "boolean",
                    "id": "#single_sample_sv_callers.cwl/merge_estimate_sv_distance"
                },
                {
                    "type": "int",
                    "id": "#single_sample_sv_callers.cwl/merge_max_distance"
                },
                {
                    "type": "int",
                    "id": "#single_sample_sv_callers.cwl/merge_min_sv_size"
                },
                {
                    "type": "int",
                    "id": "#single_sample_sv_callers.cwl/merge_min_svs"
                },
                {
                    "type": "boolean",
                    "id": "#single_sample_sv_callers.cwl/merge_same_strand"
                },
                {
                    "type": "boolean",
                    "id": "#single_sample_sv_callers.cwl/merge_same_type"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#single_sample_sv_callers.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#single_sample_sv_callers.cwl/smoove_exclude_regions"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#single_sample_sv_callers.cwl/snps_vcf"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#single_sample_sv_callers.cwl/sv_alt_abundance_percentage"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#single_sample_sv_callers.cwl/sv_paired_count"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#single_sample_sv_callers.cwl/sv_split_count"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_merge/bcftools_merged_annotated_tsv",
                    "id": "#single_sample_sv_callers.cwl/bcftools_merged_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_merge/bcftools_merged_filtered_annotated_tsv",
                    "id": "#single_sample_sv_callers.cwl/bcftools_merged_filtered_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_merge/bcftools_merged_sv_vcf",
                    "id": "#single_sample_sv_callers.cwl/bcftools_merged_vcf"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvkit/cn_diagram",
                    "id": "#single_sample_sv_callers.cwl/cn_diagram"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvkit/cn_scatter_plot",
                    "id": "#single_sample_sv_callers.cwl/cn_scatter_plot"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvkit_filter/filtered_vcf",
                    "id": "#single_sample_sv_callers.cwl/cnvkit_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvkit_raw_index/indexed_vcf",
                    "id": "#single_sample_sv_callers.cwl/cnvkit_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvnator/cn_file",
                    "id": "#single_sample_sv_callers.cwl/cnvnator_cn_file"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvnator_filter/filtered_vcf",
                    "id": "#single_sample_sv_callers.cwl/cnvnator_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvnator/root_file",
                    "id": "#single_sample_sv_callers.cwl/cnvnator_root"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvnator_raw_index/indexed_vcf",
                    "id": "#single_sample_sv_callers.cwl/cnvnator_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_manta/all_candidates",
                    "id": "#single_sample_sv_callers.cwl/manta_all_candidates"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#single_sample_sv_callers.cwl/run_manta/diploid_variants",
                    "id": "#single_sample_sv_callers.cwl/manta_diploid_variants"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_manta_filter/filtered_vcf",
                    "id": "#single_sample_sv_callers.cwl/manta_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_manta/small_candidates",
                    "id": "#single_sample_sv_callers.cwl/manta_small_candidates"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#single_sample_sv_callers.cwl/run_manta/somatic_variants",
                    "id": "#single_sample_sv_callers.cwl/manta_somatic_variants"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#single_sample_sv_callers.cwl/run_manta/tumor_only_variants",
                    "id": "#single_sample_sv_callers.cwl/manta_tumor_only_variants"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_smoove_filter/filtered_vcf",
                    "id": "#single_sample_sv_callers.cwl/smoove_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_smoove/output_vcf",
                    "id": "#single_sample_sv_callers.cwl/smoove_output_variants"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_merge/survivor_merged_annotated_tsv",
                    "id": "#single_sample_sv_callers.cwl/survivor_merged_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_merge/survivor_merged_sv_vcf",
                    "id": "#single_sample_sv_callers.cwl/survivor_merged_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvkit/tumor_antitarget_coverage",
                    "id": "#single_sample_sv_callers.cwl/tumor_antitarget_coverage"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvkit/tumor_bin_level_ratios",
                    "id": "#single_sample_sv_callers.cwl/tumor_bin_level_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvkit/tumor_segmented_ratios",
                    "id": "#single_sample_sv_callers.cwl/tumor_segmented_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#single_sample_sv_callers.cwl/run_cnvkit/tumor_target_coverage",
                    "id": "#single_sample_sv_callers.cwl/tumor_target_coverage"
                }
            ],
            "steps": [
                {
                    "run": "#cnvkit_single_sample.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/cnvkit_vcf_name",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit/cnvkit_vcf_name"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnvkit_diagram",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit/diagram"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnvkit_drop_low_coverage",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit/drop_low_coverage"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnvkit_male_reference",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit/male_reference"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnvkit_method",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit/method"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnvkit_reference_cnn",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit/reference_cnn"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnvkit_scatter_plot",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit/scatter_plot"
                        },
                        {
                            "default": "cn",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit/segment_filter"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/bam",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit/tumor_bam"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_cnvkit/cn_diagram",
                        "#single_sample_sv_callers.cwl/run_cnvkit/cn_scatter_plot",
                        "#single_sample_sv_callers.cwl/run_cnvkit/tumor_antitarget_coverage",
                        "#single_sample_sv_callers.cwl/run_cnvkit/tumor_target_coverage",
                        "#single_sample_sv_callers.cwl/run_cnvkit/tumor_bin_level_ratios",
                        "#single_sample_sv_callers.cwl/run_cnvkit/tumor_segmented_ratios",
                        "#single_sample_sv_callers.cwl/run_cnvkit/cnvkit_vcf"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_cnvkit"
                },
                {
                    "run": "#sv_depth_caller_filter.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/cnv_deletion_depth",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit_filter/deletion_depth"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnv_duplication_depth",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit_filter/duplication_depth"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnv_filter_min_size",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit_filter/min_sv_size"
                        },
                        {
                            "default": "filtered_cnvkit.vcf",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit_filter/output_vcf_name"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/reference",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit_filter/reference"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/run_cnvkit/cnvkit_vcf",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit_filter/sv_vcf"
                        },
                        {
                            "default": "cnvkit",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_cnvkit_filter/filtered_vcf"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_cnvkit_filter"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/run_cnvkit/cnvkit_vcf",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit_raw_bgzip/file"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_cnvkit_raw_bgzip/bgzipped_file"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_cnvkit_raw_bgzip"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/run_cnvkit_raw_bgzip/bgzipped_file",
                            "id": "#single_sample_sv_callers.cwl/run_cnvkit_raw_index/vcf"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_cnvkit_raw_index/indexed_vcf"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_cnvkit_raw_index"
                },
                {
                    "run": "#cnvnator.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/bam",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator/bam"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/reference",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator/reference"
                        },
                        {
                            "default": "cnvnator",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator/sample_name"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_cnvnator/vcf",
                        "#single_sample_sv_callers.cwl/run_cnvnator/root_file",
                        "#single_sample_sv_callers.cwl/run_cnvnator/cn_file"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_cnvnator"
                },
                {
                    "run": "#sv_depth_caller_filter.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/cnv_deletion_depth",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator_filter/deletion_depth"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnv_duplication_depth",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator_filter/duplication_depth"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnv_filter_min_size",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator_filter/min_sv_size"
                        },
                        {
                            "default": "filtered_cnvnator.vcf",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator_filter/output_vcf_name"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/reference",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator_filter/reference"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/run_cnvnator/vcf",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator_filter/sv_vcf"
                        },
                        {
                            "default": "cnvnator",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_cnvnator_filter/filtered_vcf"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_cnvnator_filter"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/run_cnvnator/vcf",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator_raw_bgzip/file"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_cnvnator_raw_bgzip/bgzipped_file"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_cnvnator_raw_bgzip"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/run_cnvnator_raw_bgzip/bgzipped_file",
                            "id": "#single_sample_sv_callers.cwl/run_cnvnator_raw_index/vcf"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_cnvnator_raw_index/indexed_vcf"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_cnvnator_raw_index"
                },
                {
                    "run": "#manta_somatic.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/manta_call_regions",
                            "id": "#single_sample_sv_callers.cwl/run_manta/call_regions"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/manta_non_wgs",
                            "id": "#single_sample_sv_callers.cwl/run_manta/non_wgs"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/manta_output_contigs",
                            "id": "#single_sample_sv_callers.cwl/run_manta/output_contigs"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/reference",
                            "id": "#single_sample_sv_callers.cwl/run_manta/reference"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/bam",
                            "id": "#single_sample_sv_callers.cwl/run_manta/tumor_bam"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_manta/diploid_variants",
                        "#single_sample_sv_callers.cwl/run_manta/somatic_variants",
                        "#single_sample_sv_callers.cwl/run_manta/all_candidates",
                        "#single_sample_sv_callers.cwl/run_manta/small_candidates",
                        "#single_sample_sv_callers.cwl/run_manta/tumor_only_variants"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_manta"
                },
                {
                    "run": "#sv_paired_read_caller_filter.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/sv_alt_abundance_percentage",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/abundance_percentage"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/bam",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/bam"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnv_deletion_depth",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/deletion_depth"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnv_duplication_depth",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/duplication_depth"
                        },
                        {
                            "default": "filtered_manta.vcf",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/output_vcf_name"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/reference",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/reference"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/snps_vcf",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/snps_vcf"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/sv_paired_count",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/sv_paired_count"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/sv_split_count",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/sv_split_count"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/run_manta/tumor_only_variants",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/sv_vcf"
                        },
                        {
                            "default": "manta",
                            "id": "#single_sample_sv_callers.cwl/run_manta_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_manta_filter/filtered_vcf"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_manta_filter"
                },
                {
                    "run": "#merge_svs.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/merge_estimate_sv_distance",
                            "id": "#single_sample_sv_callers.cwl/run_merge/estimate_sv_distance"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/genome_build",
                            "id": "#single_sample_sv_callers.cwl/run_merge/genome_build"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/merge_max_distance",
                            "id": "#single_sample_sv_callers.cwl/run_merge/max_distance_to_merge"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/merge_min_svs",
                            "id": "#single_sample_sv_callers.cwl/run_merge/minimum_sv_calls"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/merge_min_sv_size",
                            "id": "#single_sample_sv_callers.cwl/run_merge/minimum_sv_size"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/merge_same_strand",
                            "id": "#single_sample_sv_callers.cwl/run_merge/same_strand"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/merge_same_type",
                            "id": "#single_sample_sv_callers.cwl/run_merge/same_type"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/snps_vcf",
                            "id": "#single_sample_sv_callers.cwl/run_merge/snps_vcf"
                        },
                        {
                            "source": [
                                "#single_sample_sv_callers.cwl/run_cnvkit_filter/filtered_vcf",
                                "#single_sample_sv_callers.cwl/run_cnvnator_filter/filtered_vcf",
                                "#single_sample_sv_callers.cwl/run_manta_filter/filtered_vcf",
                                "#single_sample_sv_callers.cwl/run_smoove_filter/filtered_vcf"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#single_sample_sv_callers.cwl/run_merge/sv_vcfs"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_merge/bcftools_merged_sv_vcf",
                        "#single_sample_sv_callers.cwl/run_merge/bcftools_merged_annotated_tsv",
                        "#single_sample_sv_callers.cwl/run_merge/bcftools_merged_filtered_annotated_tsv",
                        "#single_sample_sv_callers.cwl/run_merge/survivor_merged_sv_vcf",
                        "#single_sample_sv_callers.cwl/run_merge/survivor_merged_annotated_tsv"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_merge"
                },
                {
                    "run": "#smoove.cwl",
                    "in": [
                        {
                            "source": [
                                "#single_sample_sv_callers.cwl/bam"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#single_sample_sv_callers.cwl/run_smoove/bams"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/smoove_exclude_regions",
                            "id": "#single_sample_sv_callers.cwl/run_smoove/exclude_regions"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/reference",
                            "id": "#single_sample_sv_callers.cwl/run_smoove/reference"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_smoove/output_vcf"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_smoove"
                },
                {
                    "run": "#sv_paired_read_caller_filter.cwl",
                    "in": [
                        {
                            "source": "#single_sample_sv_callers.cwl/sv_alt_abundance_percentage",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/abundance_percentage"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/bam",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/bam"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnv_deletion_depth",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/deletion_depth"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/cnv_duplication_depth",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/duplication_depth"
                        },
                        {
                            "default": "filtered_smoove.vcf",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/output_vcf_name"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/reference",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/reference"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/snps_vcf",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/snps_vcf"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/sv_paired_count",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/sv_paired_count"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/sv_split_count",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/sv_split_count"
                        },
                        {
                            "source": "#single_sample_sv_callers.cwl/run_smoove/output_vcf",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/sv_vcf"
                        },
                        {
                            "default": "smoove",
                            "id": "#single_sample_sv_callers.cwl/run_smoove_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#single_sample_sv_callers.cwl/run_smoove_filter/filtered_vcf"
                    ],
                    "id": "#single_sample_sv_callers.cwl/run_smoove_filter"
                }
            ],
            "id": "#single_sample_sv_callers.cwl"
        },
        {
            "class": "Workflow",
            "label": "Filter single sample sv vcf from depth callers(cnvkit/cnvnator)",
            "inputs": [
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/deletion_depth"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/duplication_depth"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/min_sv_size"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/output_vcf_name"
                },
                {
                    "type": "string",
                    "id": "#sv_depth_caller_filter.cwl/reference"
                },
                {
                    "type": "File",
                    "id": "#sv_depth_caller_filter.cwl/sv_vcf"
                },
                {
                    "type": [
                        {
                            "type": "enum",
                            "symbols": [
                                "#sv_depth_caller_filter.cwl/vcf_source/cnvkit",
                                "#sv_depth_caller_filter.cwl/vcf_source/cnvnator"
                            ]
                        }
                    ],
                    "id": "#sv_depth_caller_filter.cwl/vcf_source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#sv_depth_caller_filter.cwl/filtered_vcf_index/indexed_vcf",
                    "id": "#sv_depth_caller_filter.cwl/filtered_vcf"
                }
            ],
            "steps": [
                {
                    "run": "#filter_sv_vcf_depth.cwl",
                    "in": [
                        {
                            "source": "#sv_depth_caller_filter.cwl/deletion_depth",
                            "id": "#sv_depth_caller_filter.cwl/depth_filter/deletion_depth"
                        },
                        {
                            "source": "#sv_depth_caller_filter.cwl/duplication_depth",
                            "id": "#sv_depth_caller_filter.cwl/depth_filter/duplication_depth"
                        },
                        {
                            "source": "#sv_depth_caller_filter.cwl/size_filter/filtered_sv_vcf",
                            "id": "#sv_depth_caller_filter.cwl/depth_filter/input_vcf"
                        },
                        {
                            "source": "#sv_depth_caller_filter.cwl/output_vcf_name",
                            "id": "#sv_depth_caller_filter.cwl/depth_filter/output_vcf_name"
                        },
                        {
                            "source": "#sv_depth_caller_filter.cwl/vcf_source",
                            "id": "#sv_depth_caller_filter.cwl/depth_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#sv_depth_caller_filter.cwl/depth_filter/filtered_sv_vcf"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/depth_filter"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#sv_depth_caller_filter.cwl/depth_filter/filtered_sv_vcf",
                            "id": "#sv_depth_caller_filter.cwl/filtered_vcf_bgzip/file"
                        }
                    ],
                    "out": [
                        "#sv_depth_caller_filter.cwl/filtered_vcf_bgzip/bgzipped_file"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/filtered_vcf_bgzip"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#sv_depth_caller_filter.cwl/filtered_vcf_bgzip/bgzipped_file",
                            "id": "#sv_depth_caller_filter.cwl/filtered_vcf_index/vcf"
                        }
                    ],
                    "out": [
                        "#sv_depth_caller_filter.cwl/filtered_vcf_index/indexed_vcf"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/filtered_vcf_index"
                },
                {
                    "run": "#filter_sv_vcf_size.cwl",
                    "in": [
                        {
                            "source": "#sv_depth_caller_filter.cwl/sv_vcf",
                            "id": "#sv_depth_caller_filter.cwl/size_filter/input_vcf"
                        },
                        {
                            "default": "min_len",
                            "id": "#sv_depth_caller_filter.cwl/size_filter/size_method"
                        },
                        {
                            "source": "#sv_depth_caller_filter.cwl/min_sv_size",
                            "id": "#sv_depth_caller_filter.cwl/size_filter/sv_size"
                        }
                    ],
                    "out": [
                        "#sv_depth_caller_filter.cwl/size_filter/filtered_sv_vcf"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/size_filter"
                }
            ],
            "id": "#sv_depth_caller_filter.cwl"
        },
        {
            "class": "Workflow",
            "label": "Filter single sample sv vcf from paired read callers(Manta/Smoove)",
            "inputs": [
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/abundance_percentage"
                },
                {
                    "type": "File",
                    "id": "#sv_paired_read_caller_filter.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/deletion_depth"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/duplication_depth"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/output_vcf_name"
                },
                {
                    "type": "string",
                    "id": "#sv_paired_read_caller_filter.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/snps_vcf"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/sv_paired_count"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/sv_split_count"
                },
                {
                    "type": "File",
                    "id": "#sv_paired_read_caller_filter.cwl/sv_vcf"
                },
                {
                    "type": [
                        {
                            "type": "enum",
                            "symbols": [
                                "#sv_paired_read_caller_filter.cwl/vcf_source/manta",
                                "#sv_paired_read_caller_filter.cwl/vcf_source/smoove"
                            ]
                        }
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/vcf_source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#sv_paired_read_caller_filter.cwl/filtered_vcf_index/indexed_vcf",
                    "id": "#sv_paired_read_caller_filter.cwl/filtered_vcf"
                }
            ],
            "steps": [
                {
                    "run": "#filter_sv_vcf_depth.cwl",
                    "in": [
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/deletion_depth",
                            "id": "#sv_paired_read_caller_filter.cwl/depth_filter/deletion_depth"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/duplication_depth",
                            "id": "#sv_paired_read_caller_filter.cwl/depth_filter/duplication_depth"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/duphold_annotate/annotated_sv_vcf",
                            "id": "#sv_paired_read_caller_filter.cwl/depth_filter/input_vcf"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/output_vcf_name",
                            "id": "#sv_paired_read_caller_filter.cwl/depth_filter/output_vcf_name"
                        },
                        {
                            "default": "duphold",
                            "id": "#sv_paired_read_caller_filter.cwl/depth_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#sv_paired_read_caller_filter.cwl/depth_filter/filtered_sv_vcf"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/depth_filter"
                },
                {
                    "run": "#duphold.cwl",
                    "in": [
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/bam",
                            "id": "#sv_paired_read_caller_filter.cwl/duphold_annotate/bam"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/reference",
                            "id": "#sv_paired_read_caller_filter.cwl/duphold_annotate/reference"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/snps_vcf",
                            "id": "#sv_paired_read_caller_filter.cwl/duphold_annotate/snps_vcf"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/read_support_filter/filtered_sv_vcf",
                            "id": "#sv_paired_read_caller_filter.cwl/duphold_annotate/sv_vcf"
                        }
                    ],
                    "out": [
                        "#sv_paired_read_caller_filter.cwl/duphold_annotate/annotated_sv_vcf"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/duphold_annotate"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/depth_filter/filtered_sv_vcf",
                            "id": "#sv_paired_read_caller_filter.cwl/filtered_vcf_bgzip/file"
                        }
                    ],
                    "out": [
                        "#sv_paired_read_caller_filter.cwl/filtered_vcf_bgzip/bgzipped_file"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/filtered_vcf_bgzip"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/filtered_vcf_bgzip/bgzipped_file",
                            "id": "#sv_paired_read_caller_filter.cwl/filtered_vcf_index/vcf"
                        }
                    ],
                    "out": [
                        "#sv_paired_read_caller_filter.cwl/filtered_vcf_index/indexed_vcf"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/filtered_vcf_index"
                },
                {
                    "run": "#filter_sv_vcf_read_support.cwl",
                    "in": [
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/abundance_percentage",
                            "id": "#sv_paired_read_caller_filter.cwl/read_support_filter/abundance_percentage"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/sv_vcf",
                            "id": "#sv_paired_read_caller_filter.cwl/read_support_filter/input_vcf"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/sv_paired_count",
                            "id": "#sv_paired_read_caller_filter.cwl/read_support_filter/paired_count"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/sv_split_count",
                            "id": "#sv_paired_read_caller_filter.cwl/read_support_filter/split_count"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/vcf_source",
                            "id": "#sv_paired_read_caller_filter.cwl/read_support_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#sv_paired_read_caller_filter.cwl/read_support_filter/filtered_sv_vcf"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/read_support_filter"
                }
            ],
            "id": "#sv_paired_read_caller_filter.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Insert an arbitrary string at a specific line of a file",
            "baseCommand": [
                "awk"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:xenial"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "arguments": [
                "-v",
                {
                    "valueFrom": "n=$(inputs.line_number)"
                },
                "-v",
                {
                    "valueFrom": "s=$(inputs.some_text)"
                },
                "NR == n {print s} {print}"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 7
                    },
                    "id": "#add_string_at_line.cwl/input_file"
                },
                {
                    "type": "int",
                    "id": "#add_string_at_line.cwl/line_number"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "$(inputs.input_file.basename).commented",
                    "id": "#add_string_at_line.cwl/output_name"
                },
                {
                    "type": "string",
                    "id": "#add_string_at_line.cwl/some_text"
                }
            ],
            "stdout": "$(inputs.output_name)",
            "outputs": [
                {
                    "type": "File",
                    "id": "#add_string_at_line.cwl/output_file",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    }
                }
            ],
            "id": "#add_string_at_line.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Insert an arbitrary string at a specific line of a gzipped file",
            "baseCommand": [
                "zcat"
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "arguments": [
                {
                    "valueFrom": "$(inputs.input_file.path)"
                },
                {
                    "shellQuote": false,
                    "valueFrom": "|"
                },
                "awk",
                "-v",
                {
                    "valueFrom": "n=$(inputs.line_number)"
                },
                "-v",
                {
                    "valueFrom": "s=$(inputs.some_text)"
                },
                "NR == n {print s} {print}",
                {
                    "shellQuote": false,
                    "valueFrom": "|"
                },
                "/opt/htslib/bin/bgzip"
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#add_string_at_line_bgzipped.cwl/input_file"
                },
                {
                    "type": "int",
                    "id": "#add_string_at_line_bgzipped.cwl/line_number"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "$(inputs.input_file.basename).commented.gz",
                    "id": "#add_string_at_line_bgzipped.cwl/output_name"
                },
                {
                    "type": "string",
                    "id": "#add_string_at_line_bgzipped.cwl/some_text"
                }
            ],
            "stdout": "$(inputs.output_name)",
            "outputs": [
                {
                    "type": "File",
                    "id": "#add_string_at_line_bgzipped.cwl/output_file",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    }
                }
            ],
            "id": "#add_string_at_line_bgzipped.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "add VEP annotation to report",
            "baseCommand": [
                "vep-annotation-reporter"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "griffithlab/vatools:3.1.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "arguments": [
                "-o",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.prefix).annotated.tsv"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "variants",
                    "id": "#add_vep_fields_to_table.cwl/prefix"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-t"
                    },
                    "id": "#add_vep_fields_to_table.cwl/tsv"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#add_vep_fields_to_table.cwl/vcf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "default": [
                        "Consequence",
                        "SYMBOL",
                        "Feature",
                        "HGVSc",
                        "HGVSp"
                    ],
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#add_vep_fields_to_table.cwl/vep_fields"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.prefix).annotated.tsv"
                    },
                    "id": "#add_vep_fields_to_table.cwl/annotated_variants_tsv"
                }
            ],
            "id": "#add_vep_fields_to_table.cwl"
        },
        {
            "class": "CommandLineTool",
            "arguments": [
                "AnnotSV",
                "-bedtools",
                "/usr/bin/bedtools",
                "-outputDir",
                "$(runtime.outdir)"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/annotsv-cwl:2.1"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-genomeBuild"
                    },
                    "id": "#annotsv.cwl/genome_build"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-SVinputFile"
                    },
                    "doc": "vcf file to filter",
                    "id": "#annotsv.cwl/input_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "AnnotSV.tsv",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-outputFile"
                    },
                    "doc": "output file name",
                    "id": "#annotsv.cwl/output_tsv_name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-vcfFiles",
                        "itemSeparator": ","
                    },
                    "doc": "snps vcf(s) for adding hom/het snp counts found within svs",
                    "id": "#annotsv.cwl/snps_vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_tsv_name)"
                    },
                    "id": "#annotsv.cwl/sv_variants_tsv"
                }
            ],
            "id": "#annotsv.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "filter AnnotSV tsv output generated from a bcftools merged vcf",
            "baseCommand": [
                "python3",
                "AnnotSV_filter.py"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "python:3"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "AnnotSV_filter.py",
                            "entry": "import argparse\nimport csv\nimport sys\n\nparser = argparse.ArgumentParser()\nparser.add_argument('--input', '-i', dest=\"input\", help='input AnnotSV tsv file', required=True, action=\"store\")\nparser.add_argument('--output', '-o', dest=\"output\", help='output tsv file name', required=True, action=\"store\")\nparser.add_argument('--filtering_frequency', dest=\"filtering_frequency\", help=\"frequency to filter with\", action=\"store\", type=float, default=\"0.05\")\nparser.add_argument('--all-CDS', dest=\"CDS\", help=\"Do not require a positive CoDing Sequence overlap\", action=\"store_true\")\nparser.add_argument('--ignore-pass-filter', dest=\"filter\", help=\"Do not require calls to have a PASS filter\", action=\"store_true\")\n\nargs = parser.parse_args()\ninput_file_name  = args.input\noutput_file_name = args.output\nfiltering_frequency = args.filtering_frequency\nall_cds = args.CDS\nignore_pass_filter = args.filter\n\nwith open(input_file_name, 'r') as file_in, open(output_file_name, 'w') as file_out:\n    file_in = csv.DictReader(file_in, delimiter='\\t')\n    file_out = csv.DictWriter(file_out, fieldnames=file_in.fieldnames, delimiter='\\t')\n    file_out.writeheader()\n    total_sv_count = 0\n    pass_sv_count = 0\n    for row in file_in:\n        total_sv_count += 1\n        if(row['AnnotSV type'] == 'split' \\\n            and (row['FILTER'] == 'PASS' or ignore_pass_filter) \\\n            and (int(row['CDS length']) > 0 or all_cds) \\\n            and float(row['IMH_AF']) < filtering_frequency\n            and float(row['1000g_max_AF']) < filtering_frequency\n            and not(float(row['DGV_LOSS_Frequency']) > filtering_frequency and 'DEL' in row['SV type']) \n            and not(float(row['DGV_GAIN_Frequency']) < filtering_frequency and ('DUP' in row['SV type'] or 'INS' in row['SV type']))\n            and not(('Manta' in row['ID'] and 'IMPRECISE' in row['INFO']) or (row['QUAL'] != '.' and 'IMPRECISE' in row['INFO'])) ):\n            file_out.writerow(row)\n            pass_sv_count += 1\n    print(\"total sv count:\",total_sv_count)\n    print(\"total sv passed count:\",pass_sv_count)\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--all-CDS"
                    },
                    "id": "#annotsv_filter.cwl/all_CDS"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--input"
                    },
                    "id": "#annotsv_filter.cwl/annotsv_tsv"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--filtering_frequency"
                    },
                    "id": "#annotsv_filter.cwl/filtering_frequency"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--ignore-pass-filter"
                    },
                    "id": "#annotsv_filter.cwl/ignore_pass_filter"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "filtered-bcftools-merged-AnnotSV.tsv",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--output"
                    },
                    "id": "#annotsv_filter.cwl/output_tsv_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_tsv_name)"
                    },
                    "id": "#annotsv_filter.cwl/filtered_tsv"
                }
            ],
            "id": "#annotsv_filter.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "apply BQSR",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx16g",
                "-jar",
                "/opt/GenomeAnalysisTK.jar",
                "-T",
                "PrintReads"
            ],
            "arguments": [
                "-o",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.output_name).bam"
                },
                "-preserveQ",
                "6",
                "-SQQ",
                "10",
                "-SQQ",
                "20",
                "-SQQ",
                "30",
                "-nct",
                "8",
                "--disable_indel_quals"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 18000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/gatk-cwl:3.6.0"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-I",
                        "position": 2
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#apply_bqsr.cwl/bam"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-BQSR",
                        "position": 3
                    },
                    "id": "#apply_bqsr.cwl/bqsr_table"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "final",
                    "id": "#apply_bqsr.cwl/output_name"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "-R",
                        "position": 1
                    },
                    "id": "#apply_bqsr.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name).bam"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#apply_bqsr.cwl/bqsr_bam"
                }
            ],
            "id": "#apply_bqsr.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "BAM to CRAM conversion",
            "baseCommand": [
                "/opt/samtools/bin/samtools",
                "view",
                "-C"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "stdout": "$(inputs.bam.nameroot).cram",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#bam_to_cram.cwl/bam"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "-T",
                        "position": 1
                    },
                    "id": "#bam_to_cram.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#bam_to_cram.cwl/cram",
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).cram"
                    }
                }
            ],
            "id": "#bam_to_cram.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/opt/bcftools/bin/bcftools",
                "merge"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/bcftools-cwl:1.9"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--force-samples"
                    },
                    "doc": "resolve duplicate sample names",
                    "id": "#bcftools_merge.cwl/force_merge"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#bcftools_merge.cwl/merge_method/none",
                            "#bcftools_merge.cwl/merge_method/snps",
                            "#bcftools_merge.cwl/merge_method/indels",
                            "#bcftools_merge.cwl/merge_method/both",
                            "#bcftools_merge.cwl/merge_method/all",
                            "#bcftools_merge.cwl/merge_method/id"
                        ]
                    },
                    "default": "none",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--merge"
                    },
                    "doc": "method used to merge allow multiallelic indels/snps",
                    "id": "#bcftools_merge.cwl/merge_method"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--missing-to-ref"
                    },
                    "doc": "assume genotypes at missing sites are 0/0",
                    "id": "#bcftools_merge.cwl/missing_ref"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#bcftools_merge.cwl/output_type/b",
                            "#bcftools_merge.cwl/output_type/u",
                            "#bcftools_merge.cwl/output_type/z",
                            "#bcftools_merge.cwl/output_type/v"
                        ]
                    },
                    "default": "z",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--output-type"
                    },
                    "doc": "output file format",
                    "id": "#bcftools_merge.cwl/output_type"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "bcftools_merged.vcf.gz",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--output"
                    },
                    "doc": "output vcf file name",
                    "id": "#bcftools_merge.cwl/output_vcf_name"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 6
                    },
                    "doc": "input bgzipped tabix indexed vcfs to merge",
                    "id": "#bcftools_merge.cwl/vcfs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_name)"
                    },
                    "id": "#bcftools_merge.cwl/merged_sv_vcf"
                }
            ],
            "id": "#bcftools_merge.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "bgzip VCF",
            "baseCommand": [
                "/opt/htslib/bin/bgzip"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "stdout": "$(inputs.file.basename).gz",
            "arguments": [
                "-c"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#bgzip.cwl/file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#bgzip.cwl/bgzipped_file",
                    "outputBinding": {
                        "glob": "$(inputs.file.basename).gz"
                    }
                }
            ],
            "id": "#bgzip.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "create BQSR table",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx16g",
                "-jar",
                "/opt/GenomeAnalysisTK.jar",
                "-T",
                "BaseRecalibrator"
            ],
            "arguments": [
                "-o",
                {
                    "valueFrom": "$(runtime.outdir)/bqsr.table"
                },
                "--preserve_qscores_less_than",
                "6",
                "--disable_auto_index_creation_and_locking_when_reading_rods",
                "--disable_bam_indexing",
                "-dfrac",
                ".1",
                "-nct",
                "4"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 18000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/gatk-cwl:3.6.0"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-I",
                        "position": 3
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#bqsr.cwl/bam"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "-L"
                        }
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "default": [
                        "chr1",
                        "chr2",
                        "chr3",
                        "chr4",
                        "chr5",
                        "chr6",
                        "chr7",
                        "chr8",
                        "chr9",
                        "chr10",
                        "chr11",
                        "chr12",
                        "chr13",
                        "chr14",
                        "chr15",
                        "chr16",
                        "chr17",
                        "chr18",
                        "chr19",
                        "chr20",
                        "chr21",
                        "chr22"
                    ],
                    "id": "#bqsr.cwl/intervals"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "-knownSites",
                            "position": 4
                        }
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#bqsr.cwl/known_sites"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "-R",
                        "position": 2
                    },
                    "id": "#bqsr.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "bqsr.table"
                    },
                    "id": "#bqsr.cwl/bqsr_table"
                }
            ],
            "id": "#bqsr.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/usr/bin/python",
                "/usr/local/bin/cnvkit.py",
                "batch"
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "etal/cnvkit:0.9.5"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "ramMin": 4000,
                    "tmpdirMin": 10000
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--access"
                    },
                    "id": "#cnvkit_batch.cwl/access"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--targets"
                    },
                    "id": "#cnvkit_batch.cwl/bait_intervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "prefix": "--diagram"
                    },
                    "id": "#cnvkit_batch.cwl/diagram"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "--drop-low-coverage"
                    },
                    "id": "#cnvkit_batch.cwl/drop_low_coverage"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-y"
                    },
                    "id": "#cnvkit_batch.cwl/male_reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "hybrid",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "--method"
                    },
                    "id": "#cnvkit_batch.cwl/method"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--normal"
                    },
                    "id": "#cnvkit_batch.cwl/normal_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--fasta"
                    },
                    "id": "#cnvkit_batch.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-r"
                    },
                    "id": "#cnvkit_batch.cwl/reference_cnn"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 8,
                        "prefix": "--scatter"
                    },
                    "id": "#cnvkit_batch.cwl/scatter_plot"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#cnvkit_batch.cwl/tumor_bam"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot)-diagram.pdf"
                    },
                    "id": "#cnvkit_batch.cwl/cn_diagram"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot)-scatter.pdf"
                    },
                    "id": "#cnvkit_batch.cwl/cn_scatter_plot"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${  \n    var glob_base = \".antitarget.bed\";\n    if (inputs.bait_intervals) {\n        glob_base = inputs.bait_intervals.nameroot + glob_base;\n    }   \n    return glob_base;\n}  \n"
                    },
                    "id": "#cnvkit_batch.cwl/intervals_antitarget"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n    var glob_base = \".target.bed\";\n    if (inputs.bait_intervals) {\n        glob_base = inputs.bait_intervals.nameroot + glob_base;\n    }\n    return glob_base;\n}\n"
                    },
                    "id": "#cnvkit_batch.cwl/intervals_target"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n    var glob_base = \".antitargetcoverage.cnn\";\n    if (inputs.normal_bam) {\n        glob_base = inputs.normal_bam.nameroot + glob_base;\n    }\n    return glob_base;\n}\n"
                    },
                    "id": "#cnvkit_batch.cwl/normal_antitarget_coverage"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n    var glob_base = \".targetcoverage.cnn\";\n    if (inputs.normal_bam) {\n        glob_base = inputs.normal_bam.nameroot + glob_base;\n    }\n    return glob_base;\n}\n"
                    },
                    "id": "#cnvkit_batch.cwl/normal_target_coverage"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "reference.cnn"
                    },
                    "id": "#cnvkit_batch.cwl/reference_coverage"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).antitargetcoverage.cnn"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_antitarget_coverage"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).cnr"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_bin_level_ratios"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).cns"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_segmented_ratios"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).targetcoverage.cnn"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_target_coverage"
                }
            ],
            "id": "#cnvkit_batch.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Convert default cnvkit .cns output to standard vcf format",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "etal/cnvkit:0.9.5"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "/usr/bin/python",
                "/usr/local/bin/cnvkit.py",
                "call"
            ],
            "arguments": [
                {
                    "position": -1,
                    "valueFrom": "$(inputs.male_reference)",
                    "prefix": "-y"
                },
                "-o",
                "adjusted.tumor.cns",
                {
                    "shellQuote": false,
                    "valueFrom": "&&"
                },
                "/usr/bin/python",
                "/usr/local/bin/cnvkit.py",
                "export",
                "vcf",
                "adjusted.tumor.cns"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--cnr"
                    },
                    "id": "#cnvkit_vcf_export.cwl/cnr_file"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": -2
                    },
                    "id": "#cnvkit_vcf_export.cwl/cns_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-y"
                    },
                    "id": "#cnvkit_vcf_export.cwl/male_reference"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-o"
                    },
                    "id": "#cnvkit_vcf_export.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#cnvkit_vcf_export.cwl/segment_filter/ampdel",
                                "#cnvkit_vcf_export.cwl/segment_filter/ci",
                                "#cnvkit_vcf_export.cwl/segment_filter/cn",
                                "#cnvkit_vcf_export.cwl/segment_filter/sem"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": -3,
                        "prefix": "--filter"
                    },
                    "doc": "method for filtering/merging neighboring copy number segments",
                    "id": "#cnvkit_vcf_export.cwl/segment_filter"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#cnvkit_vcf_export.cwl/cnvkit_vcf"
                }
            ],
            "id": "#cnvkit_vcf_export.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Run CNVnator to calculate copy number variations in WGS samples",
            "baseCommand": [
                "/bin/bash",
                "run_cnvnator.sh"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/cnvnator-cwl:0.4"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 20000,
                    "coresMin": 1,
                    "tmpdirMin": 10000
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "run_cnvnator.sh",
                            "entry": "#!/bin/bash\n\n#set up the environment\nsource /opt/root/bin/thisroot.sh\n\nset -eou pipefail\n\n# set vars\nBAM=\"$1\"\nBIN_SIZE=\"$2\"\nCHROMOSOMES=\"$3\"\nREFERENCE=\"$4\"\nSAMPLE=\"$5\"\n\n# create directory to store fasta files. CNVnator wants chromosomes in individual files\n# while with later versions of CNVnator these steps will accept a fasta.gz file the cnvnator2VCF.pl will not\nmkdir FASTA_CHRS\nawk 'BEGIN { CHROM=\"\" } { if ($1~\"^>\") CHROM=substr($1,2); print $0 > \"FASTA_CHRS/\"CHROM\".fa\" }' \"$REFERENCE\"\n\n# extract read mapping from input bam(single sample)\ncnvnator -root \"$SAMPLE.root\" -tree \"$BAM\" -chrom $CHROMOSOMES\n# generate read depth histogram\ncnvnator -root \"$SAMPLE.root\" -his \"$BIN_SIZE\" -d FASTA_CHRS/ -chrom $CHROMOSOMES\n# calculate statistics\ncnvnator -root \"$SAMPLE.root\" -stat \"$BIN_SIZE\" -chrom $CHROMOSOMES\n# read depth signal partitioning\ncnvnator -root \"$SAMPLE.root\" -partition \"$BIN_SIZE\" -chrom $CHROMOSOMES\n# cnv calling\ncnvnator -root \"$SAMPLE.root\" -call \"$BIN_SIZE\" -chrom $CHROMOSOMES > \"$SAMPLE.CNVnator.cn\"\n\n# convert to vcf\ncnvnator2VCF.pl -reference \"$REFERENCE\" \"$SAMPLE.CNVnator.cn\" FASTA_CHRS/ >  \"$SAMPLE.CNVnator.vcf\"\nexit 0\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "BAM or CRAM input",
                    "id": "#cnvnator.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 100,
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "Bin size used to calculate coverage",
                    "id": "#cnvnator.cwl/bin_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "default": [
                        "chr1",
                        "chr2",
                        "chr3",
                        "chr4",
                        "chr5",
                        "chr6",
                        "chr7",
                        "chr8",
                        "chr9",
                        "chr10",
                        "chr11",
                        "chr12",
                        "chr13",
                        "chr14",
                        "chr15",
                        "chr16",
                        "chr17",
                        "chr18",
                        "chr19",
                        "chr20",
                        "chr21",
                        "chr22",
                        "chrX",
                        "chrY"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "itemSeparator": " "
                    },
                    "doc": "List of chromosomes to run CNVnator on",
                    "id": "#cnvnator.cwl/chromosomes"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "Reference used to generate the alignments",
                    "id": "#cnvnator.cwl/reference"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 5
                    },
                    "doc": "Sample name used for output file naming",
                    "id": "#cnvnator.cwl/sample_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sample_name).CNVnator.cn"
                    },
                    "id": "#cnvnator.cwl/cn_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sample_name).root"
                    },
                    "id": "#cnvnator.cwl/root_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sample_name).CNVnator.vcf"
                    },
                    "id": "#cnvnator.cwl/vcf"
                }
            ],
            "id": "#cnvnator.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "collect alignment summary metrics",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx16g",
                "-jar",
                "/usr/picard/picard.jar",
                "CollectAlignmentSummaryMetrics"
            ],
            "arguments": [
                "OUTPUT=",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.bam.nameroot).AlignmentSummaryMetrics.txt"
                }
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 18000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/picard-cwl:2.18.1"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "INPUT="
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#collect_alignment_summary_metrics.cwl/bam"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "METRIC_ACCUMULATION_LEVEL="
                    },
                    "id": "#collect_alignment_summary_metrics.cwl/metric_accumulation_level"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "REFERENCE_SEQUENCE="
                    },
                    "id": "#collect_alignment_summary_metrics.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).AlignmentSummaryMetrics.txt"
                    },
                    "id": "#collect_alignment_summary_metrics.cwl/alignment_summary_metrics"
                }
            ],
            "id": "#collect_alignment_summary_metrics.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "collect gc bias metrics",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx16g",
                "-jar",
                "/usr/picard/picard.jar",
                "CollectGcBiasMetrics"
            ],
            "arguments": [
                "O=",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.sample_name).GcBiasMetrics.txt"
                },
                "CHART=",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.sample_name).GcBiasMetricsChart.pdf"
                },
                "S=",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.sample_name).GcBiasMetricsSummary.txt"
                }
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 18000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/cle:v1.3.1"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "I="
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#collect_gc_bias_metrics.cwl/bam"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "METRIC_ACCUMULATION_LEVEL="
                    },
                    "id": "#collect_gc_bias_metrics.cwl/metric_accumulation_level"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "R="
                    },
                    "id": "#collect_gc_bias_metrics.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "final",
                    "id": "#collect_gc_bias_metrics.cwl/sample_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sample_name).GcBiasMetrics.txt"
                    },
                    "id": "#collect_gc_bias_metrics.cwl/gc_bias_metrics"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sample_name).GcBiasMetricsChart.pdf"
                    },
                    "id": "#collect_gc_bias_metrics.cwl/gc_bias_metrics_chart"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sample_name).GcBiasMetricsSummary.txt"
                    },
                    "id": "#collect_gc_bias_metrics.cwl/gc_bias_metrics_summary"
                }
            ],
            "id": "#collect_gc_bias_metrics.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "collect HS metrics",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx48g",
                "-jar",
                "/usr/picard/picard.jar",
                "CollectHsMetrics"
            ],
            "arguments": [
                "O=",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.bam.nameroot).$(inputs.output_prefix)-HsMetrics.txt"
                }
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 52000
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/picard-cwl:2.18.1"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "BAIT_INTERVALS="
                    },
                    "id": "#collect_hs_metrics.cwl/bait_intervals"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "I="
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#collect_hs_metrics.cwl/bam"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "METRIC_ACCUMULATION_LEVEL="
                    },
                    "id": "#collect_hs_metrics.cwl/metric_accumulation_level"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "MINIMUM_BASE_QUALITY="
                    },
                    "id": "#collect_hs_metrics.cwl/minimum_base_quality"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "MINIMUM_MAPPING_QUALITY="
                    },
                    "id": "#collect_hs_metrics.cwl/minimum_mapping_quality"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "out",
                    "id": "#collect_hs_metrics.cwl/output_prefix"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "PER_BASE_COVERAGE=",
                        "valueFrom": "${\n    if(self) {\n        return inputs.bam.nameroot + \".\" + inputs.output_prefix + \"-PerBaseCoverage.txt\"\n    } else {\n        return false;\n    }\n}\n"
                    },
                    "id": "#collect_hs_metrics.cwl/per_base_coverage"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "PER_TARGET_COVERAGE=",
                        "valueFrom": "${\n    if(self) {\n        return inputs.bam.nameroot + \".\" + inputs.output_prefix + \"-PerTargetCoverage.txt\"\n    } else {\n        return false;\n    }\n}\n"
                    },
                    "id": "#collect_hs_metrics.cwl/per_target_coverage"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "R="
                    },
                    "id": "#collect_hs_metrics.cwl/reference"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "TARGET_INTERVALS="
                    },
                    "id": "#collect_hs_metrics.cwl/target_intervals"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).$(inputs.output_prefix)-HsMetrics.txt"
                    },
                    "id": "#collect_hs_metrics.cwl/hs_metrics"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).$(inputs.output_prefix)-PerBaseCoverage.txt"
                    },
                    "id": "#collect_hs_metrics.cwl/per_base_coverage_metrics"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).$(inputs.output_prefix)-PerTargetCoverage.txt"
                    },
                    "id": "#collect_hs_metrics.cwl/per_target_coverage_metrics"
                }
            ],
            "id": "#collect_hs_metrics.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "collect insert size metrics",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx16g",
                "-jar",
                "/usr/picard/picard.jar",
                "CollectInsertSizeMetrics"
            ],
            "arguments": [
                "O=",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.bam.nameroot).InsertSizeMetrics.txt"
                },
                "H=",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.bam.nameroot).InsertSizeHistogram.pdf"
                }
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 18000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/picard-cwl:2.18.1"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "I="
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#collect_insert_size_metrics.cwl/bam"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "METRIC_ACCUMULATION_LEVEL="
                    },
                    "id": "#collect_insert_size_metrics.cwl/metric_accumulation_level"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "REFERENCE_SEQUENCE="
                    },
                    "id": "#collect_insert_size_metrics.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).InsertSizeHistogram.pdf"
                    },
                    "id": "#collect_insert_size_metrics.cwl/insert_size_histogram"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).InsertSizeMetrics.txt"
                    },
                    "id": "#collect_insert_size_metrics.cwl/insert_size_metrics"
                }
            ],
            "id": "#collect_insert_size_metrics.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "collect WGS metrics",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx16g",
                "-jar",
                "/usr/picard/picard.jar",
                "CollectWgsMetrics"
            ],
            "arguments": [
                "O=",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.sample_name).WgsMetrics.txt"
                }
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 18000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/picard-cwl:2.18.1"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "I="
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#collect_wgs_metrics.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "INTERVALS="
                    },
                    "id": "#collect_wgs_metrics.cwl/intervals"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "Minimum base quality for a base to contribute coverage. (N bases are considered to have negative infinite quality and will be excluded regardless of this value.)",
                    "inputBinding": {
                        "prefix": "MINIMUM_BASE_QUALITY="
                    },
                    "id": "#collect_wgs_metrics.cwl/minimum_base_quality"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "Minimum mapping quality for a read to contribute coverage.",
                    "inputBinding": {
                        "prefix": "MINIMUM_MAPPING_QUALITY="
                    },
                    "id": "#collect_wgs_metrics.cwl/minimum_mapping_quality"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "R="
                    },
                    "id": "#collect_wgs_metrics.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "final",
                    "id": "#collect_wgs_metrics.cwl/sample_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sample_name).WgsMetrics.txt"
                    },
                    "id": "#collect_wgs_metrics.cwl/wgs_metrics"
                }
            ],
            "id": "#collect_wgs_metrics.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "/usr/bin/duphold",
            "arguments": [
                "--threads",
                "$(runtime.cores)"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 10000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/duphold-cwl:0.1.5"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--bam"
                    },
                    "doc": "aligned bam/cram file",
                    "id": "#duphold.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "duphold_annotated.vcf",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--output"
                    },
                    "doc": "output vcf file name",
                    "id": "#duphold.cwl/output_vcf_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--fasta"
                    },
                    "doc": "reference used to align bam",
                    "id": "#duphold.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--snp"
                    },
                    "doc": "snps vcf file to annotate hom/het variant counts within sv",
                    "id": "#duphold.cwl/snps_vcf"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--vcf"
                    },
                    "doc": "sv vcf file to annotate",
                    "id": "#duphold.cwl/sv_vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_name)"
                    },
                    "id": "#duphold.cwl/annotated_sv_vcf"
                }
            ],
            "id": "#duphold.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/bin/bash",
                "filter_sv_vcf_depth.sh"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/bcftools-cwl:1.9"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "filter_sv_vcf_depth.sh",
                            "entry": "#!/bin/bash\nset -eou pipefail\n\nINPUT_VCF=\"$1\"\nOUTPUT_VCF=\"$2\"\nDEL_DEPTH=\"$3\"\nDUP_DEPTH=\"$4\"\nVCF_SOURCE=\"$5\"\n\nif [ \"$VCF_SOURCE\" == \"cnvnator\" ]; then\n  echo \"Running filter for cnvnator vcf\"\n  filter_expression=\"(natorRD>$DUP_DEPTH | natorRD<$DEL_DEPTH)\"\nelif [ \"$VCF_SOURCE\" ==  \"cnvkit\" ]; then\n  echo \"Running filter for cnvkit vcf\"\n  filter_expression=\"(FOLD_CHANGE>$DUP_DEPTH | FOLD_CHANGE<$DEL_DEPTH)\"\nelif [ \"$VCF_SOURCE\" ==  \"duphold\" ]; then\n  echo \"Running filter for vcf annotated by duphold\"\n  filter_expression=\"((SVTYPE='DEL' & FMT/DHFFC[0] < $DEL_DEPTH) | (SVTYPE='DUP' & FMT/DHBFC[0] > $DUP_DEPTH) | SVTYPE='BND' | SVTYPE='INS' | SVTYPE='INV')\"\nelse\n  echo \"vcf source: '$VCF_SOURCE' is not supported for SV filtering\"\n  exit 1\nfi\n/opt/bcftools/bin/bcftools filter \"$INPUT_VCF\" -o \"$OUTPUT_VCF\" -i \"$filter_expression\"\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "default": 0.75,
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "Depth for deletions must be less than this cutoff to pass the filter.",
                    "id": "#filter_sv_vcf_depth.cwl/deletion_depth"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "default": 1.25,
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "Depth for duplications must be greater than this cutoff to pass the filter.",
                    "id": "#filter_sv_vcf_depth.cwl/duplication_depth"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "vcf file to filter",
                    "id": "#filter_sv_vcf_depth.cwl/input_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "filtered_cnv.vcf",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "output vcf file name",
                    "id": "#filter_sv_vcf_depth.cwl/output_vcf_name"
                },
                {
                    "type": [
                        {
                            "type": "enum",
                            "symbols": [
                                "#filter_sv_vcf_depth.cwl/vcf_source/cnvnator",
                                "#filter_sv_vcf_depth.cwl/vcf_source/cnvkit",
                                "#filter_sv_vcf_depth.cwl/vcf_source/duphold"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 5
                    },
                    "doc": "source caller of the vcf input file",
                    "id": "#filter_sv_vcf_depth.cwl/vcf_source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_name)"
                    },
                    "id": "#filter_sv_vcf_depth.cwl/filtered_sv_vcf"
                }
            ],
            "id": "#filter_sv_vcf_depth.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/bin/bash",
                "filter_sv_vcf_read_support.sh"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/bcftools-cwl:1.9"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "filter_sv_vcf_read_support.sh",
                            "entry": "#!/bin/bash\nset -eou pipefail\n\nabundance=\"$1\"\ninput_vcf=\"$2\"\noutput_vcf=\"$3\"\npaired_count=\"$4\"\nsplit_count=\"$5\"\nvcf_source=\"$6\"\n\nif [ \"$vcf_source\" == \"smoove\" ]; then\n  echo \"Running filter for smoove vcf\"\n  filter_expression=\"((AS >= $split_count) && (AP >= $paired_count) && ((AP+AS) / (AP+RP+AS+RS) >= $abundance))\"\nelif [ \"$vcf_source\" ==  \"manta\" ]; then\n  echo \"Running filter for manta vcf\"\n  filter_expression=\"((SR[0:*]=\\\".\\\" || (SR[0:1] >= $split_count)) && (PR[0:1] >= $paired_count) && ((SR[0:*]=\\\".\\\" && (PR[0:1] / (PR[0:0]+PR[0:1]) >= $abundance))|| ((SR[0:1]+PR[0:1]) / (SR[0:0]+SR[0:1]+PR[0:1]+PR[0:0]) >= $abundance)))\"\nelse\n  echo \"vcf source: '$vcf_source' is not supported for SV filtering\"\n  exit 1\nfi\n\n/opt/bcftools/bin/bcftools filter \"$input_vcf\" -o \"$output_vcf\" -i \"$filter_expression\"\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "default": 0.1,
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "required alternate read abundance percentage to pass",
                    "id": "#filter_sv_vcf_read_support.cwl/abundance_percentage"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "vcf file to filter",
                    "id": "#filter_sv_vcf_read_support.cwl/input_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "filtered_sv.vcf",
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "output vcf file name",
                    "id": "#filter_sv_vcf_read_support.cwl/output_vcf_name"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 2,
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "number of alternate paired reads support needed to pass",
                    "id": "#filter_sv_vcf_read_support.cwl/paired_count"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 2,
                    "inputBinding": {
                        "position": 5
                    },
                    "doc": "if present in variant, number of alternate split reads support needed to pass",
                    "id": "#filter_sv_vcf_read_support.cwl/split_count"
                },
                {
                    "type": [
                        {
                            "type": "enum",
                            "symbols": [
                                "#filter_sv_vcf_read_support.cwl/vcf_source/manta",
                                "#filter_sv_vcf_read_support.cwl/vcf_source/smoove"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 6
                    },
                    "doc": "source caller of the vcf input file",
                    "id": "#filter_sv_vcf_read_support.cwl/vcf_source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_name)"
                    },
                    "id": "#filter_sv_vcf_read_support.cwl/filtered_sv_vcf"
                }
            ],
            "id": "#filter_sv_vcf_read_support.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/bin/bash",
                "filter_sv_vcf_size.sh"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/bcftools-cwl:1.9"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "filter_sv_vcf_size.sh",
                            "entry": "#!/bin/bash\nset -eou pipefail\n\nINPUT_VCF=\"$1\"\nOUTPUT_VCF=\"$2\"\nSV_SIZE=\"$3\"\nFILTER_METHOD=\"$4\"\n\nif [ \"$FILTER_METHOD\" == \"max_len\" ]; then\n  echo \"Running filter for max size svs\"\n  filter_expression=\"ABS(SVLEN) <= $SV_SIZE\"\nelif [ \"$FILTER_METHOD\" ==  \"min_len\" ]; then\n  echo \"Running filter for min size svs\"\n  filter_expression=\"ABS(SVLEN) >= $SV_SIZE\"\nelse\n  echo \"Filter method: '$FILTER_METHOD' is not supported for size SV filtering\"\n  exit 1\nfi\n/opt/bcftools/bin/bcftools filter \"$INPUT_VCF\" -o \"$OUTPUT_VCF\" -i \"$filter_expression\"\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "vcf file to filter",
                    "id": "#filter_sv_vcf_size.cwl/input_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "filtered_sv_size.vcf",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "output vcf file name",
                    "id": "#filter_sv_vcf_size.cwl/output_vcf_name"
                },
                {
                    "type": [
                        {
                            "type": "enum",
                            "symbols": [
                                "#filter_sv_vcf_size.cwl/size_method/max_len",
                                "#filter_sv_vcf_size.cwl/size_method/min_len"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "method for size filtering",
                    "id": "#filter_sv_vcf_size.cwl/size_method"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 50000,
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "size in bp used for filtering",
                    "id": "#filter_sv_vcf_size.cwl/sv_size"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_name)"
                    },
                    "id": "#filter_sv_vcf_size.cwl/filtered_sv_vcf"
                }
            ],
            "id": "#filter_sv_vcf_size.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Coding Variant filter",
            "baseCommand": [
                "/usr/bin/perl",
                "/usr/bin/vcf_check.pl"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/vep_helper-cwl:1.0.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "arguments": [
                {
                    "valueFrom": "$(inputs.vcf.path)"
                },
                {
                    "valueFrom": "$(runtime.outdir)/annotated.coding_variant_filtered.vcf"
                },
                "/usr/bin/perl",
                "/opt/vep/src/ensembl-vep/filter_vep",
                "--format",
                "vcf",
                "-o",
                {
                    "valueFrom": "$(runtime.outdir)/annotated.coding_variant_filtered.vcf"
                },
                "--ontology",
                "--filter",
                "Consequence is coding_sequence_variant"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-i",
                        "position": 1
                    },
                    "id": "#filter_vcf_coding_variant.cwl/vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "annotated.coding_variant_filtered.vcf"
                    },
                    "id": "#filter_vcf_coding_variant.cwl/filtered_vcf"
                }
            ],
            "id": "#filter_vcf_coding_variant.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Custom allele frequency filter",
            "baseCommand": [
                "/usr/bin/perl",
                "/usr/bin/vcf_check.pl"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/vep_helper-cwl:1.0.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "arguments": [
                {
                    "valueFrom": "$(inputs.vcf.path)"
                },
                {
                    "valueFrom": "$(runtime.outdir)/annotated.af_filtered.vcf"
                },
                "/usr/bin/perl",
                "/opt/vep/src/ensembl-vep/filter_vep",
                "--format",
                "vcf",
                "-o",
                {
                    "valueFrom": "$(runtime.outdir)/annotated.af_filtered.vcf"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#filter_vcf_custom_allele_freq.cwl/field_name"
                },
                {
                    "type": "float",
                    "inputBinding": {
                        "valueFrom": "${\n    return [\n        \"--filter\",\n        [\n            inputs.field_name, \"<\", inputs.maximum_population_allele_frequency,\n            \"or not\", inputs.field_name\n        ].join(\" \")\n    ]\n}\n",
                        "position": 2
                    },
                    "id": "#filter_vcf_custom_allele_freq.cwl/maximum_population_allele_frequency"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-i",
                        "position": 1
                    },
                    "id": "#filter_vcf_custom_allele_freq.cwl/vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "annotated.af_filtered.vcf"
                    },
                    "id": "#filter_vcf_custom_allele_freq.cwl/filtered_vcf"
                }
            ],
            "id": "#filter_vcf_custom_allele_freq.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "GATK HaplotypeCaller",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx8g",
                "-jar",
                "/opt/GenomeAnalysisTK.jar",
                "-T",
                "GenotypeGVCFs"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 9000
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/gatk-cwl:3.5.0"
                }
            ],
            "arguments": [
                "-o",
                "genotype.vcf.gz"
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "--variant"
                        }
                    },
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#gatk_genotypegvcfs.cwl/gvcfs"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "-R",
                        "position": 1
                    },
                    "id": "#gatk_genotypegvcfs.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "genotype.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk_genotypegvcfs.cwl/genotype_vcf"
                }
            ],
            "id": "#gatk_genotypegvcfs.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "GATK HaplotypeCaller",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx8g",
                "-jar",
                "/opt/GenomeAnalysisTK.jar",
                "-T",
                "HaplotypeCaller"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 10000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/gatk-cwl:3.5.0"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-I",
                        "position": 2
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#gatk_haplotype_caller.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-contamination",
                        "position": 7
                    },
                    "id": "#gatk_haplotype_caller.cwl/contamination_fraction"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--dbsnp",
                        "position": 6
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk_haplotype_caller.cwl/dbsnp_vcf"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#gatk_haplotype_caller.cwl/emit_reference_confidence/NONE",
                            "#gatk_haplotype_caller.cwl/emit_reference_confidence/BP_RESOLUTION",
                            "#gatk_haplotype_caller.cwl/emit_reference_confidence/GVCF"
                        ]
                    },
                    "inputBinding": {
                        "prefix": "-ERC",
                        "position": 3
                    },
                    "id": "#gatk_haplotype_caller.cwl/emit_reference_confidence"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "-GQB"
                        }
                    },
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#gatk_haplotype_caller.cwl/gvcf_gq_bands"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "-L"
                        }
                    },
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#gatk_haplotype_caller.cwl/intervals"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "doc": "maximum number of alternate alleles to genotype",
                    "inputBinding": {
                        "prefix": "--max_alternate_alleles",
                        "position": 8
                    },
                    "id": "#gatk_haplotype_caller.cwl/max_alternate_alleles"
                },
                {
                    "type": "string",
                    "default": "output.g.vcf.gz",
                    "inputBinding": {
                        "prefix": "-o",
                        "position": 12
                    },
                    "id": "#gatk_haplotype_caller.cwl/output_file_name"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "filters to apply to reads before analysis",
                    "inputBinding": {
                        "prefix": "--read_filter",
                        "position": 11
                    },
                    "id": "#gatk_haplotype_caller.cwl/read_filter"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "-R",
                        "position": 1
                    },
                    "id": "#gatk_haplotype_caller.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "parameter to pass to the index creator",
                    "inputBinding": {
                        "prefix": "--variant_index_parameter",
                        "position": 10
                    },
                    "id": "#gatk_haplotype_caller.cwl/variant_index_parameter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#gatk_haplotype_caller.cwl/variant_index_type/DYNAMIC_SEEK",
                                "#gatk_haplotype_caller.cwl/variant_index_type/DYNAMIC_SIZE",
                                "#gatk_haplotype_caller.cwl/variant_index_type/LINEAR",
                                "#gatk_haplotype_caller.cwl/variant_index_type/INTERVAL"
                            ]
                        }
                    ],
                    "doc": "type of IndexCreator to use for VCF/BCF indices",
                    "inputBinding": {
                        "prefix": "--variant_index_type",
                        "position": 9
                    },
                    "id": "#gatk_haplotype_caller.cwl/variant_index_type"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file_name)"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk_haplotype_caller.cwl/gvcf"
                }
            ],
            "id": "#gatk_haplotype_caller.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "samtools index",
            "arguments": [
                "/opt/samtools/bin/samtools",
                "index",
                "$(runtime.outdir)/$(inputs.bam.basename)",
                "$(runtime.outdir)/$(inputs.bam.basename).bai",
                {
                    "valueFrom": " && ",
                    "shellQuote": false
                },
                "cp",
                "$(inputs.bam.basename).bai",
                "$(runtime.outdir)/$(inputs.bam.nameroot).bai"
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "${ var f = inputs.bam; delete f.secondaryFiles; return f }"
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#index_bam.cwl/bam"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".bai",
                        "^.bai"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.bam.basename)"
                    },
                    "id": "#index_bam.cwl/indexed_bam"
                }
            ],
            "id": "#index_bam.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "samtools index cram",
            "arguments": [
                "/opt/samtools/bin/samtools",
                "index",
                "$(runtime.outdir)/$(inputs.cram.basename)",
                "$(runtime.outdir)/$(inputs.cram.basename).crai",
                {
                    "valueFrom": " && ",
                    "shellQuote": false
                },
                "cp",
                "$(inputs.cram.basename).crai",
                "$(runtime.outdir)/$(inputs.cram.nameroot).crai"
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "${ var f = inputs.cram; delete f.secondaryFiles; return f }"
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#index_cram.cwl/cram"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".crai",
                        "^.crai"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.cram.basename)"
                    },
                    "id": "#index_cram.cwl/indexed_cram"
                }
            ],
            "id": "#index_cram.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "vcf index",
            "arguments": [
                "cp",
                "$(inputs.vcf.path)",
                "$(runtime.outdir)/$(inputs.vcf.basename)",
                {
                    "valueFrom": " && ",
                    "shellQuote": false
                },
                "/usr/bin/tabix",
                "-p",
                "vcf"
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "valueFrom": "$(self.basename)",
                        "position": 1
                    },
                    "id": "#index_vcf.cwl/vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.vcf.basename)"
                    },
                    "id": "#index_vcf.cwl/indexed_vcf"
                }
            ],
            "id": "#index_vcf.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Set up and execute manta",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/manta_somatic-cwl:1.5.0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 12,
                    "ramMin": 24000,
                    "tmpdirMin": 10000
                }
            ],
            "baseCommand": [
                "/usr/bin/python",
                "/usr/bin/manta/bin/configManta.py"
            ],
            "arguments": [
                {
                    "position": -1,
                    "valueFrom": "$(runtime.outdir)",
                    "prefix": "--runDir"
                },
                {
                    "shellQuote": false,
                    "valueFrom": "&&"
                },
                "/usr/bin/python",
                "runWorkflow.py",
                "-m",
                "local",
                {
                    "position": 1,
                    "valueFrom": "$(runtime.cores)",
                    "prefix": "-j"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": -5,
                        "prefix": "--callRegions"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "doc": "bgzip-compressed, tabix-indexed BED file specifiying regions to which variant analysis will be restricted",
                    "id": "#manta_somatic.cwl/call_regions"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": -6,
                        "prefix": "--exome"
                    },
                    "doc": "toggles on settings for WES",
                    "id": "#manta_somatic.cwl/non_wgs"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": -2,
                        "prefix": "--normalBam"
                    },
                    "secondaryFiles": "${if (self.nameext === \".bam\") {return self.basename + \".bai\"} else {return self.basename + \".crai\"}}",
                    "id": "#manta_somatic.cwl/normal_bam"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": -7,
                        "prefix": "--outputContig"
                    },
                    "doc": "if true, outputs assembled contig sequences in final VCF files, in the INFO field CONTIG",
                    "id": "#manta_somatic.cwl/output_contigs"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "position": -4,
                        "prefix": "--referenceFasta"
                    },
                    "id": "#manta_somatic.cwl/reference"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": -3,
                        "prefix": "--tumorBam"
                    },
                    "secondaryFiles": "${if (self.nameext === \".bam\") {return self.basename + \".bai\"} else {return self.basename + \".crai\"}}",
                    "id": "#manta_somatic.cwl/tumor_bam"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "results/variants/candidateSV.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#manta_somatic.cwl/all_candidates"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "results/variants/diploidSV.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#manta_somatic.cwl/diploid_variants"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "results/variants/candidateSmallIndels.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#manta_somatic.cwl/small_candidates"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "results/variants/somaticSV.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#manta_somatic.cwl/somatic_variants"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "results/variants/tumorSV.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#manta_somatic.cwl/tumor_only_variants"
                }
            ],
            "id": "#manta_somatic.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Mark duplicates and Sort",
            "baseCommand": [
                "/bin/bash",
                "markduplicates_helper.sh"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "coresMin": 8,
                    "ramMin": 40000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/mark_duplicates-cwl:1.0.1"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "markduplicates_helper.sh",
                            "entry": "set -o pipefail\nset -o errexit\n\ndeclare MD_BARCODE_TAG\nif [ ! -z \"$6\" ]; then\n  MD_BARCODE_TAG=\"BARCODE_TAG=$6\"\n/usr/bin/java -Xmx16g -jar /opt/picard/picard.jar MarkDuplicates I=$1 O=/dev/stdout ASSUME_SORT_ORDER=$5 METRICS_FILE=$4 QUIET=true COMPRESSION_LEVEL=0 VALIDATION_STRINGENCY=LENIENT \"$MD_BARCODE_TAG\" | /usr/bin/sambamba sort -t $2 -m 18G -o $3 /dev/stdin\nelse\n  /usr/bin/java -Xmx16g -jar /opt/picard/picard.jar MarkDuplicates I=$1 O=/dev/stdout ASSUME_SORT_ORDER=$5 METRICS_FILE=$4 QUIET=true COMPRESSION_LEVEL=0 VALIDATION_STRINGENCY=LENIENT | /usr/bin/sambamba sort -t $2 -m 18G -o $3 /dev/stdin\nfi\n"
                        }
                    ]
                }
            ],
            "arguments": [
                {
                    "position": 2,
                    "valueFrom": "$(runtime.cores)"
                },
                {
                    "position": 4,
                    "valueFrom": "$(inputs.bam.nameroot).mark_dups_metrics.txt"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#mark_duplicates_and_sort.cwl/bam"
                },
                {
                    "type": "string",
                    "default": "queryname",
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#mark_duplicates_and_sort.cwl/input_sort_order"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "MarkedSorted.bam",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#mark_duplicates_and_sort.cwl/output_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).mark_dups_metrics.txt"
                    },
                    "id": "#mark_duplicates_and_sort.cwl/metrics_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#mark_duplicates_and_sort.cwl/sorted_bam"
                }
            ],
            "id": "#mark_duplicates_and_sort.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Samtools: merge",
            "baseCommand": [
                "/opt/samtools/bin/samtools",
                "merge"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000,
                    "coresMin": 4
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                }
            ],
            "arguments": [
                "$(inputs.name).merged.bam",
                {
                    "prefix": "--threads",
                    "valueFrom": "$(runtime.cores)"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#merge_bams_samtools.cwl/bams"
                },
                {
                    "type": "string",
                    "id": "#merge_bams_samtools.cwl/name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.name).merged.bam"
                    },
                    "id": "#merge_bams_samtools.cwl/merged_bam"
                }
            ],
            "id": "#merge_bams_samtools.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "sort BAM by name",
            "baseCommand": [
                "/usr/bin/sambamba",
                "sort"
            ],
            "arguments": [
                "-t",
                {
                    "valueFrom": "$(runtime.cores)"
                },
                "-m",
                "22G",
                "-n",
                "-o",
                {
                    "valueFrom": "$(inputs.bam.nameroot).NameSorted.bam"
                }
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 26000,
                    "coresMin": 8
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/sambamba-cwl:0.6.4"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#name_sort.cwl/bam"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).NameSorted.bam"
                    },
                    "id": "#name_sort.cwl/name_sorted_bam"
                }
            ],
            "id": "#name_sort.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "samtools flagstat",
            "baseCommand": [
                "/opt/samtools/bin/samtools",
                "flagstat"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                }
            ],
            "stdout": "$(inputs.bam.basename).flagstat",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#samtools_flagstat.cwl/bam"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#samtools_flagstat.cwl/flagstats",
                    "outputBinding": {
                        "glob": "$(inputs.bam.basename).flagstat"
                    }
                }
            ],
            "id": "#samtools_flagstat.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "SelectVariants (GATK 3.6)",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx4g",
                "-jar",
                "/opt/GenomeAnalysisTK.jar",
                "-T",
                "SelectVariants"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 6000,
                    "tmpdirMin": 25000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/gatk-cwl:3.6.0"
                }
            ],
            "arguments": [
                "-o",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.output_vcf_basename).vcf.gz"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--excludeFiltered",
                        "position": 4
                    },
                    "id": "#select_variants.cwl/exclude_filtered"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-L",
                        "position": 3
                    },
                    "id": "#select_variants.cwl/interval_list"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "select_variants",
                    "id": "#select_variants.cwl/output_vcf_basename"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "-R",
                        "position": 1
                    },
                    "id": "#select_variants.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "--sample_name",
                        "position": 5
                    },
                    "doc": "include genotypes from this sample",
                    "id": "#select_variants.cwl/samples_to_include"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#select_variants.cwl/select_type/INDEL",
                                "#select_variants.cwl/select_type/SNP",
                                "#select_variants.cwl/select_type/MIXED",
                                "#select_variants.cwl/select_type/MNP",
                                "#select_variants.cwl/select_type/SYMBOLIC",
                                "#select_variants.cwl/select_type/NO_VARIATION"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-selectType",
                        "position": 6
                    },
                    "doc": "select only a certain type of variants",
                    "id": "#select_variants.cwl/select_type"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--variant",
                        "position": 2
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#select_variants.cwl/vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_basename).vcf.gz"
                    },
                    "id": "#select_variants.cwl/filtered_vcf"
                }
            ],
            "id": "#select_variants.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "align with bwa_mem and tag",
            "doc": "Due to workflow runner limitations, use sequence_align_and_tag_adapter.cwl subworkflow to call this",
            "baseCommand": [
                "/bin/bash",
                "sequence_alignment_helper.sh"
            ],
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#sequence_data.yml/sequence_data"
                        }
                    ]
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 8,
                    "ramMin": 20000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/alignment_helper-cwl:1.0.0"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "sequence_alignment_helper.sh",
                            "entry": "set -o pipefail\nset -o errexit\nset -o nounset\n\nwhile getopts \"b:?1:?2:?g:r:n:\" opt; do\n    case \"$opt\" in\n        b)\n            MODE=bam\n            BAM=\"$OPTARG\"\n            ;;\n        1)\n            MODE=fastq\n            FASTQ1=\"$OPTARG\"\n            ;;\n        2)  \n            MODE=fastq\n            FASTQ2=\"$OPTARG\"\n            ;;\n        g)\n            READGROUP=\"$OPTARG\"\n            ;;\n        r)\n            REFERENCE=\"$OPTARG\"\n            ;;\n        n)\n            NTHREADS=\"$OPTARG\"\n            ;;\n    esac\ndone\n\nif [[ \"$MODE\" == 'fastq' ]]; then\n    /usr/local/bin/bwa mem -K 100000000 -t \"$NTHREADS\" -Y -R \"$READGROUP\" \"$REFERENCE\" \"$FASTQ1\" \"$FASTQ2\" | /usr/local/bin/samblaster -a --addMateTags | /opt/samtools/bin/samtools view -b -S /dev/stdin\nfi\nif [[ \"$MODE\" == 'bam' ]]; then\n    /usr/bin/java -Xmx4g -jar /opt/picard/picard.jar SamToFastq I=\"$BAM\" INTERLEAVE=true INCLUDE_NON_PF_READS=true FASTQ=/dev/stdout | /usr/local/bin/bwa mem -K 100000000 -t \"$NTHREADS\" -Y -p -R \"$READGROUP\" \"$REFERENCE\" /dev/stdin | /usr/local/bin/samblaster -a --addMateTags | /opt/samtools/bin/samtools view -b -S /dev/stdin\nfi\n"
                        }
                    ]
                }
            ],
            "stdout": "refAlign.bam",
            "arguments": [
                {
                    "valueFrom": "$(runtime.cores)",
                    "position": 5,
                    "prefix": "-n"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-b"
                    },
                    "id": "#sequence_align_and_tag.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-1"
                    },
                    "id": "#sequence_align_and_tag.cwl/fastq1"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-2"
                    },
                    "id": "#sequence_align_and_tag.cwl/fastq2"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-g"
                    },
                    "id": "#sequence_align_and_tag.cwl/readgroup"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-r"
                    },
                    "doc": "bwa-indexed reference file",
                    "id": "#sequence_align_and_tag.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#sequence_align_and_tag.cwl/aligned_bam",
                    "outputBinding": {
                        "glob": "refAlign.bam"
                    }
                }
            ],
            "id": "#sequence_align_and_tag.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Run Smoove v0.1.6",
            "baseCommand": "/usr/local/bin/smoove",
            "arguments": [
                "call",
                "--processes",
                "4",
                "-F"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "brentp/smoove@sha256:9d5098d3882df1443aae36922d36b5188af1cb9b8f83dab4a9ed041a6a8019cc"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 20000,
                    "coresMin": 4,
                    "tmpdirMin": 10000
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "prefix": "--genotype",
                        "position": 1
                    },
                    "doc": "Array of bams to run through lumpy, can be single or small cohort",
                    "id": "#smoove.cwl/bams"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--name",
                        "position": 2
                    },
                    "default": "SV",
                    "doc": "Used for naming the output file",
                    "id": "#smoove.cwl/cohort_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--exclude",
                        "position": 4
                    },
                    "doc": "Bed file used to exclude regions",
                    "id": "#smoove.cwl/exclude_regions"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "--fasta",
                        "position": 3
                    },
                    "doc": "Reference used to generate the bams",
                    "id": "#smoove.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.cohort_name)-smoove.genotyped.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".csi"
                    ],
                    "id": "#smoove.cwl/output_vcf"
                }
            ],
            "id": "#smoove.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Staged Renamer",
            "doc": "Renames a file by staging and then `mv`ing it.  A workaround for workflow engines that don't support rename.cwl.  If running in cwltool, use the other one instead.",
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000,
                    "coresMin": 1
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:bionic"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.original)"
                    ]
                }
            ],
            "baseCommand": [
                "/bin/mv"
            ],
            "arguments": [
                "$(inputs.original.basename)",
                "$(inputs.name)"
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#staged_rename.cwl/name"
                },
                {
                    "type": "File",
                    "id": "#staged_rename.cwl/original"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.name)"
                    },
                    "id": "#staged_rename.cwl/replacement"
                }
            ],
            "id": "#staged_rename.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Run SURVIVOR to merge SV calls",
            "baseCommand": [
                "/bin/bash",
                "/usr/bin/survivor_merge_helper.sh"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/survivor-cwl:1.0.6.2"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 2000,
                    "coresMin": 1
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 8
                    },
                    "default": "SURVIVOR-sv-merged.vcf",
                    "doc": "Used to generate the output file name",
                    "id": "#survivor.cwl/cohort_name"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "position": 6,
                        "valueFrom": "${\n  if(inputs.estimate_sv_distance){\n    return \"1\";\n  } else {\n    return \"0\";\n  }\n}\n"
                    },
                    "doc": "Estimate distance based on the size of SV",
                    "id": "#survivor.cwl/estimate_sv_distance"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "Maximum distance of variants to consider for merging",
                    "id": "#survivor.cwl/max_distance_to_merge"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "Minimum number of sv calls needed to be merged",
                    "id": "#survivor.cwl/minimum_sv_calls"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 7
                    },
                    "doc": "Minimum size of SVs to merge",
                    "id": "#survivor.cwl/minimum_sv_size"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "position": 5,
                        "valueFrom": "${\n  if(inputs.same_strand){\n    return \"1\";\n  } else {\n    return \"0\";\n  }\n}\n"
                    },
                    "doc": "Require merged SVs to be on the same strand",
                    "id": "#survivor.cwl/same_strand"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "position": 4,
                        "valueFrom": "${\n  if(inputs.same_type){\n    return \"1\";\n  } else {\n    return \"0\";\n  }\n}\n"
                    },
                    "doc": "Require merged SVs to be of the same type",
                    "id": "#survivor.cwl/same_type"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1,
                        "itemSeparator": ","
                    },
                    "doc": "Array of VCFs to merge SV calls of",
                    "id": "#survivor.cwl/vcfs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.cohort_name)"
                    },
                    "id": "#survivor.cwl/merged_vcf"
                }
            ],
            "id": "#survivor.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "SelectVariants (GATK 3.6)",
            "baseCommand": [
                "/usr/bin/java",
                "-Xmx4g",
                "-jar",
                "/opt/GenomeAnalysisTK.jar",
                "-T",
                "VariantsToTable"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 6000,
                    "tmpdirMin": 25000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/gatk-cwl:3.6.0"
                }
            ],
            "arguments": [
                "--allowMissingData",
                "-o",
                {
                    "valueFrom": "$(runtime.outdir)/variants.tsv"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "-F"
                        }
                    },
                    "default": [
                        "CHROM",
                        "POS",
                        "ID",
                        "REF",
                        "ALT",
                        "set"
                    ],
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#variants_to_table.cwl/fields"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "-GF"
                        }
                    },
                    "default": [
                        "GT",
                        "AD",
                        "DP",
                        "AF"
                    ],
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#variants_to_table.cwl/genotype_fields"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "-R",
                        "position": 1
                    },
                    "id": "#variants_to_table.cwl/reference"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--variant",
                        "position": 2
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#variants_to_table.cwl/vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "variants.tsv"
                    },
                    "id": "#variants_to_table.cwl/variants_tsv"
                }
            ],
            "id": "#variants_to_table.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Ensembl Variant Effect Predictor",
            "baseCommand": [
                "/usr/bin/perl",
                "-I",
                "/opt/lib/perl/VEP/Plugins",
                "/usr/bin/variant_effect_predictor.pl"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#vep_custom_annotation.yml/vep_custom_annotation"
                        }
                    ]
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 4,
                    "ramMin": 64000,
                    "tmpdirMin": 25000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/vep_helper-cwl:1.1.0"
                }
            ],
            "arguments": [
                "--format",
                "vcf",
                "--vcf",
                "--fork",
                "4",
                "--term",
                "SO",
                "--transcript_version",
                "--offline",
                "--cache",
                "--symbol",
                "-o",
                {
                    "valueFrom": "$(runtime.outdir)/annotated.vcf"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--dir",
                        "position": 4
                    },
                    "id": "#vep.cwl/cache_dir"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "prefix": "--coding_only",
                        "position": 3
                    },
                    "default": false,
                    "id": "#vep.cwl/coding_only"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "#vep_custom_annotation.yml/vep_custom_annotation",
                            "label": "custom type, check types directory for input format",
                            "inputBinding": {
                                "valueFrom": "${\n    return [self.annotation.check_existing ? '--check_existing' : '',\n      '--custom',\n      [self.annotation.file.path,\n      self.annotation.name,\n      self.annotation.data_format,\n      self.method,\n      self.force_report_coordinates ? 1 : 0,\n      self.annotation.vcf_fields ? self.annotation.vcf_fields : ''\n      ].filter(String).join(',')\n    ].filter(String)\n}\n",
                                "position": 6
                            }
                        }
                    ],
                    "id": "#vep.cwl/custom_annotations"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--assembly",
                        "position": 10
                    },
                    "doc": "genome assembly to use in vep. Examples: 'GRCh38' or 'GRCm38'",
                    "id": "#vep.cwl/ensembl_assembly"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--species",
                        "position": 12
                    },
                    "doc": "ensembl species - Must be present in the cache directory. Examples: 'homo_sapiens' or 'mus_musculus'",
                    "id": "#vep.cwl/ensembl_species"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--cache_version",
                        "position": 11
                    },
                    "doc": "ensembl version - Must be present in the cache directory. Example: '95'",
                    "id": "#vep.cwl/ensembl_version"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "--everything",
                        "position": 9
                    },
                    "id": "#vep.cwl/everything"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#vep.cwl/pick/pick",
                                "#vep.cwl/pick/flag_pick",
                                "#vep.cwl/pick/pick_allele",
                                "#vep.cwl/pick/per_gene",
                                "#vep.cwl/pick/pick_allele_gene",
                                "#vep.cwl/pick/flag_pick_allele",
                                "#vep.cwl/pick/flag_pick_allele_gene"
                            ]
                        }
                    ],
                    "default": "flag_pick",
                    "inputBinding": {
                        "prefix": "--",
                        "separate": false,
                        "position": 7
                    },
                    "id": "#vep.cwl/pick"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "--plugin"
                        }
                    },
                    "inputBinding": {
                        "position": 8
                    },
                    "id": "#vep.cwl/plugins"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "--fasta",
                        "position": 7
                    },
                    "id": "#vep.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--synonyms",
                        "position": 2
                    },
                    "id": "#vep.cwl/synonyms_file"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-i",
                        "position": 1
                    },
                    "id": "#vep.cwl/vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "annotated.vcf"
                    },
                    "id": "#vep.cwl/annotated_vcf"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "annotated.vcf_summary.html"
                    },
                    "id": "#vep.cwl/vep_summary"
                }
            ],
            "id": "#vep.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "verify BAM ID",
            "baseCommand": "/usr/local/bin/verifyBamID",
            "arguments": [
                "--out",
                {
                    "valueFrom": "$(runtime.outdir)/$(inputs.bam.nameroot).VerifyBamId"
                }
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/verify_bam_id-cwl:1.1.3"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--bam"
                    },
                    "id": "#verify_bam_id.cwl/bam"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--vcf"
                    },
                    "id": "#verify_bam_id.cwl/vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).VerifyBamId.depthSM"
                    },
                    "id": "#verify_bam_id.cwl/verify_bam_id_depth"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam.nameroot).VerifyBamId.selfSM"
                    },
                    "id": "#verify_bam_id.cwl/verify_bam_id_metrics"
                }
            ],
            "id": "#verify_bam_id.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
